#ifndef _TVP_PLUGIN_NATIVE_INSTANCE_HOLDER_H_
#define _TVP_PLUGIN_NATIVE_INSTANCE_HOLDER_H_

#include "TVPPlugIn.h"
#include <vector>
#include <list>

// |C^̂ݑΉ

template <typename T>
BEGIN_CLASSDEF_INHERIT(TPNativeInstanceHolder, std::vector<T>)
public:
	thisclass() : inherited()
	{
	}

	virtual ~TPNativeInstanceHolder()
	{
	}

	// lCeBuCX^XID擾
	virtual tjs_int getID(iTJSDispatch2 * objthis)
	{
		tTJSVariant val; // work
		TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(objthis, NI, _NativeInstanceID_, NULL, &val)
		return (tTVInteger)val;
	}

	// lCeBuCX^XIDZbg
	virtual void setID(iTJSDispatch2 * objthis, tjs_int id)
	{
		tTJSVariant val = (tTVInteger)id; // work
		TVP_PLUGIN_TJSDISPATCH2_PROPSET_CALLIMPL(objthis, NI, _NativeInstanceID_, NULL, &val)
		return ;
	}

	// lCeBuCX^X擾
	virtual T get(iTJSDispatch2 * objthis)
	{
		tjs_int id = getID(objthis);
		return at(id);
	}

	// lCeBuCX^X폜
	virtual void erase(tjs_int id)
	{
		T p = at(id);
		if (p != NULL) {
			delete p;
			(*this)[id] = NULL;
		}
	//	compact();
	}

	virtual void erase(iTJSDispatch2 * objthis)
	{
		tjs_int id = getID(objthis);
		erase(id);
	}

	// ID擾
	virtual tjs_int nextID()
	{
		return size();
	}

	// do GC
	virtual void compact()
	{
		tjs_int size = this->size();
		bool gcok = true;

		for (tjs_int i = 0; i < size; i++) {
			if (this->at(i) != NULL) {
				gcok = false;
				break;
			}
		}

		if (gcok) this->clear();
	}

END_CLASSDEF



// lCeBuNX
// gg 2.26 stable o܂ł͂ŗB
BEGIN_CLASSDEF(TPPseudoNativeClass)
protected:
	// TJSCreateArrayObject()āA蓮ŉȂƂȂ̂
	std::list<iTJSDispatch2 *> internalObjects;

public:
	virtual void addInternalObject(iTJSDispatch2 * obj)
	{
		if (obj != NULL) {
			internalObjects.push_back(obj);
		}
	}

	virtual void releaseInternalObjects()
	{
		std::list<iTJSDispatch2 *>::iterator it;
		for (it = internalObjects.begin(); it != internalObjects.end(); it++) {
			iTJSDispatch2 * obj = *it;
			if (obj != NULL) obj->Release();
		}
	}

END_CLASSDEF

#endif _TVP_PLUGIN_NATIVE_INSTANCE_HOLDER_H_
