#ifndef _TVP_PLUGIN_COMMON_H_
#define _TVP_PLUGIN_COMMON_H_

#include <windows.h>
#include "tp_stub.h"
#include "TPRevision.h"

#define TPFUNCCALL 
#define TPFASTCALL __fastcall


// ėp
#define BEGIN_CLASSDEF(_this) \
class _this \
{ \
typedef _this thisclass;

// PpNX
#define BEGIN_CLASSDEF_INHERIT(_this,_super) \
class _this : public _super \
{ \
typedef _this thisclass; \
typedef _super inherited;

// dpNX
#define BEGIN_CLASSDEF_INHERIT2(_this,_super1,_super2) \
class _this : public _super1, public _super2 \
{ \
typedef _this thisclass; \
typedef _super1 inherited1; \
typedef _super2 inherited2;

#define END_CLASSDEF };




#define TVP_PLUGIN_FUNCCALL_DECL(_cls) \
tjs_error TJS_INTF_METHOD _cls::FuncCall( \
	tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint, \
	tTJSVariant *result, tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis)


#define TVP_PLUGIN_FUNCCALL_DECL_ICD \
tjs_error TJS_INTF_METHOD FuncCall( \
	tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint, \
	tTJSVariant *result, tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis)

#define TVP_PLUGIN_PROPGET_DECL_ICD \
tjs_error TJS_INTF_METHOD PropGet( \
	tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint, \
	tTJSVariant *result, iTJSDispatch2 *objthis)

#define TVP_PLUGIN_PROPSET_DECL_ICD \
tjs_error TJS_INTF_METHOD PropSet( \
	tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint, \
	const tTJSVariant *param, iTJSDispatch2 *objthis)



// FuncCall()ŗLpȁiHj}NW 

// ̃p[^CfbNXϐ __tp_param_idx Iɒ`B
// ̓}NŎQƁ^XV̂łāA
// vO}̕ϐQƂ͍̂D܂ȂB
// XVȂǂĂ̂قłB

// initialize
#define TP_REQ_NUM_PARAMS(_n) \
	if(membername) return TJS_E_MEMBERNOTFOUND; \
	if (numparams < _n) return TJS_E_BADPARAMCOUNT; \
	tjs_int __tp_param_idx = 0;

// set return value
#define TP_SET_RETURN_VALUE_INT(_val)  if (result) *result = (tTVInteger)(_val);
#define TP_SET_RETURN_VALUE_REAL(_val) if (result) *result = (tTVReal)(_val);
#define TP_SET_RETURN_VALUE_PTR(_val)  if (result) *result = _val;
#define TP_SET_RETURN_VALUE_VAR(_val)  if (result) *result = _val;
#define TP_SET_RETURN_VALUE_OBJ(_val)  if (result) *result = *(new tTJSVariant(_val, _val));


// required param: type cast
#define TP_GET_REQ_PARAM_TC(_typ, _lv, _rt) _typ _lv = (_rt)*param[__tp_param_idx++];
// required param: method call
#define TP_GET_REQ_PARAM_MT(_typ, _lv, _mt) _typ _lv = param[__tp_param_idx++]->_mt;
// required param: etc
#define TP_GET_REQ_PARAM_INT(_lv)  tjs_int    _lv = (tTVInteger)*param[__tp_param_idx++];
#define TP_GET_REQ_PARAM_UINT(_lv) tjs_uint32 _lv = (tTVInteger)*param[__tp_param_idx++];
#define TP_GET_REQ_PARAM_REAL(_lv) tjs_real   _lv = (tTVReal)*param[__tp_param_idx++];
#define TP_GET_REQ_PARAM_STR(_lv)  ttstr _lv(*param[__tp_param_idx++]);
#define TP_GET_REQ_PARAM_OCT(_lv)  tTJSVariantOctet * _lv = param[__tp_param_idx++]->AsOctetNoAddRef();
#define TP_GET_REQ_PARAM_OBJ(_lv)  iTJSDispatch2 * _lv = param[__tp_param_idx++]->AsObjectNoAddRef();
#define TP_GET_REQ_PARAM_VAR(_lv)  tTJSVariant * _lv = param[__tp_param_idx++];
#define TP_GET_REQ_PARAM_CLO(_lv)  tTJSVariantClosure * _lv = &(param[__tp_param_idx++]->AsObjectClosureNoAddRef());


// check parameter type
#define TP_COND_PARAM_IS_STR (param[__tp_param_idx]->Type() == tvtString)
#define TP_COND_PARAM_IS_OCT (param[__tp_param_idx]->Type() == tvtOctet)

// check parameter type
#define TP_CHK_PARAM_MUST_STR if (param[__tp_param_idx]->Type() != tvtString) TVPThrowExceptionMessage(TJS_W("%1ɂ͕w肵Ă"), (tTJSVariant)(__tp_param_idx + 1));
#define TP_CHK_PARAM_MUST_OCT if (param[__tp_param_idx]->Type() != tvtOctet)  TVPThrowExceptionMessage(TJS_W("%1ɂ̓INebgw肵Ă"), (tTJSVariant)(__tp_param_idx + 1));


// option param: type cast
#define TP_GET_OPT_PARAM_TC(_lv, _rt) \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = (_rt)*param[__tp_param_idx]; \
	} \
	__tp_param_idx++;

// option param: decl. and set
// signed int
#define TP_GET_OPT_PARAM_INT(_lv, _def) \
	tjs_int _lv = _def; \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = (tTVInteger)*param[__tp_param_idx]; \
	} \
	__tp_param_idx++;

// unsigned int
#define TP_GET_OPT_PARAM_UINT(_lv, _def) \
	tjs_uint32 _lv = _def; \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = (tTVInteger)*param[__tp_param_idx]; \
	} \
	__tp_param_idx++;

// real
#define TP_GET_OPT_PARAM_REAL(_lv, _def) \
	tjs_real _lv = _def; \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = (tTVReal)*param[__tp_param_idx]; \
	} \
	__tp_param_idx++;

// iTJSDispatch2
#define TP_GET_OPT_PARAM_OBJ(_lv, _def) \
	iTJSDispatch2 * _lv = _def; \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = param[__tp_param_idx]->AsObjectNoAddRef(); \
	} \
	__tp_param_idx++;

// tTJSVariantClosure (IS POINTER)
#define TP_GET_OPT_PARAM_CLO(_lv, _def) \
	tTJSVariantClosure * _lv = _def; \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = &(param[__tp_param_idx]->AsObjectClosureNoAddRef()); \
	} \
	__tp_param_idx++;

// option param: method call
#define TP_GET_OPT_PARAM_MT(_lv, _mt) \
	if ((numparams > __tp_param_idx) && param[__tp_param_idx] && param[__tp_param_idx] != tvtVoid) { \
		_lv = param[__tp_param_idx]->_mt; \
	} \
	__tp_param_idx++;

// FuncCall()ŗLpȁiHj}NW ܂





// Ȃ񂾂

// func call
#define TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(_ctx, _cls, _name, _hint, _result, _nump, _pval) \
	if (TJS_FAILED( _ctx->FuncCall(0, TJS_W(#_name), _hint, _result, _nump, _pval, _ctx ))) { \
		TVPThrowExceptionMessage(TJS_W("invoking of " #_cls "." #_name "() failed.")); \
	}

// set by num
#define TVP_PLUGIN_TJSDISPATCH2_PROPSETBYNUM_CALLIMPL(_ctx, _cls, _id, _pval) \
	if (TJS_FAILED(_ctx->PropSetByNum(TJS_MEMBERENSURE, (_id), _pval, _ctx))) { \
		TVPThrowExceptionMessage(TJS_W("TVP Plugin: setting of " #_cls "[%1] failed."), (tTJSVariant)(_id)); \
	}

// get by num
#define TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(_ctx, _cls, _id, _pval) \
	if (TJS_FAILED(_ctx->PropGetByNum(TJS_MEMBERMUSTEXIST, (_id), _pval, _ctx))) { \
		TVPThrowExceptionMessage(TJS_W("TVP Plugin: getting of " #_cls "[%1] failed."), (tTJSVariant)(_id)); \
	}

// set by name
#define TVP_PLUGIN_TJSDISPATCH2_PROPSET_CALLIMPL(_ctx, _cls, _name, _hint, _pval) \
	if (TJS_FAILED(_ctx->PropSet(TJS_MEMBERENSURE, TJS_W(#_name), _hint, _pval, _ctx))) { \
		TVPThrowExceptionMessage(TJS_W("TVP Plugin: setting of " #_cls "." #_name " failed.")); \
	}

// get by name
#define TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(_ctx, _cls, _name, _hint, _val) \
	if (TJS_FAILED(_ctx->PropGet(TJS_MEMBERMUSTEXIST, TJS_W(#_name), _hint, _val, _ctx))) { \
		TVPThrowExceptionMessage(TJS_W("TVP Plugin: getting of " #_cls "." #_name " failed.")); \
	}



// get by name as object
#define TVP_PLUGIN_TJSDISPATCH2_PROPGET_DECL(_cls, _name) \
const iTJSDispatch2 * _cls##_PropGet_##_name(iTJSDispatch2 * obj)

#define TVP_PLUGIN_TJSDISPATCH2_PROPGET_DECL_IMPL(_cls, _name) \
const iTJSDispatch2 * _cls##_PropGet_##_name(iTJSDispatch2 * obj) \
{ \
	static tTJSVariant workVal; \
	static tjs_uint32 hint = 0; \
	TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(obj, _cls, _name, &hint, &workVal) \
	return workVal.AsObjectNoAddRef(); \
}

// get by num
#define TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_DECL(_typ, _cls, _id) \
const _typ _cls##_PropGetByNumAs##_id(iTJSDispatch2 * obj, tjs_int num)

#define TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_DECL_IMPL(_typ, _cls, _id) \
const _typ _cls##_PropGetByNumAs##_id(iTJSDispatch2 * obj, tjs_int num) \
{ \
	static tTJSVariant workVal; \
	TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(obj, _cls, num, &workVal) \
	return (_typ)workVal; \
}



// by num as object
#define TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_OBJ_DECL(_cls, _id) \
const iTJSDispatch2 * _cls##_PropGetByNumAsObject(iTJSDispatch2 * obj, tjs_int num)

#define TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_OBJ_DECL_IMPL(_cls, _id) \
const iTJSDispatch2 * _cls##_PropGetByNumAsObject(iTJSDispatch2 * obj, tjs_int num) \
{ \
	static tTJSVariant workVal; \
	TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(obj, _cls, num, &workVal) \
	return workVal.AsObjectNoAddRef(); \
}


// 2.25 or later

// ܂ANX̃x[XƂȂNXIuWFNg쐬܂B
#define TP_CREATE_CLASSBASE_OBJ(_name) \
tTJSNativeClassForPlugin * classobj = \
TJSCreateNativeClassForPlugin(TJS_W(#_name), Create_##_name##_NI);

//	(TJS) RXgN^錾܂B
#define TP_TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(_name) TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(_this, TJSNI_##_name, _name)

//	CX^X擾
#define TP_TJS_GET_NATIVE_INSTANCE(_name) TJS_GET_NATIVE_INSTANCE(_this, TJSNI_##_name)


/*
lCeBuCX^X

 NI_Test ̃IuWFNg쐬ĕԂ̊֐łB
q TJSCreateNativeClassForPlugin ̈Ƃēn܂B

KFCreate_{tjsclass}_NI
{tjsclass}: TJSNX
*/
#define TP_TJSNI_CREATOR_DECL(_name) \
static iTJSNativeInstance * Create_##_name##_NI() \
{ \
	return new TJSNI_##_name(); \
}

/*
lCeBuNXJn

KFCreate_{tjsclass}
{tjsclass}: TJSNX
*/
#define TP_BEGIN_TJSNC_CREATOR_DECL(_name) \
iTJSDispatch2 * Create_##_name##_NC() \
{ \
/* ܂ANX̃x[XƂȂNXIuWFNg쐬܂B classobj */ \
TP_CREATE_CLASSBASE_OBJ(_name)

#define TP_END_TJSNC_CREATOR_DECL \
	return classobj; \
}






// Array Util.
// zRs[
void Array_FuncCall_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest)
{
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	static tTJSVariant val[1] = { NULL };

	val[0] = src;
	tTJSVariant *pval[1] = { val };
	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(dest, Array, assign, &hint, &result, 1, pval)
	return;
}

void Array_FuncCall_erase(iTJSDispatch2 * src, tjs_int idx)
{
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	static tTJSVariant val[1] = { (tjs_int64)0 };

	val[0] = (tjs_int64)idx;
	tTJSVariant *pval[1] = {val};
	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(src, Array, erase, &hint, &result, 1, pval)
	return;
}

void Array_FuncCall_add(iTJSDispatch2 * src, tTJSVariant * obj)
{
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(src, Array, add, &hint, &result, 1, &obj)
	return;
}

void Array_FuncCall_clear(iTJSDispatch2 * src)
{
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(src, Array, clear, &hint, &result, 0, NULL)
	return;
}

// X,Y C^[[u
void Array_uninterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_int * x, tjs_int * y)
{
	tTJSVariant val; // work

	for (tjs_int i = 0; i < arraysize; i++) {
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(path, Array, (tjs_int)(2*i), &val)
		x[i] = (tTVInteger)val;
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(path, Array, (tjs_int)(2*i+1), &val)
		y[i] = (tTVInteger)val;
	}
}

void Array_uninterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_real * x, tjs_real * y)
{
	tTJSVariant val; // work

	for (tjs_int i = 0; i < arraysize; i++) {
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(path, Array, (tjs_int)(2*i), &val)
		x[i] = (tTVReal)val;
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(path, Array, (tjs_int)(2*i+1), &val)
		y[i] = (tTVReal)val;
	}
}



#endif _TVP_PLUGIN_COMMON_H_
