#ifndef _TVP_PLUGIN_TABLE_HOLDER_H_
#define _TVP_PLUGIN_TABLE_HOLDER_H_

#include <windows.h>
#include <math.h>
#include "tp_stub.h"

#define INT_ABS(a)	(((a)<0)?(-a):(a))

// ftHgx
#define DEFAULT_ANGLE_ACC	4096
#define DEFAULT_SIN_ACC	1024

//---------------------------------------------------------------------------
// f[^ێ
//---------------------------------------------------------------------------
class CTableHolder {
protected:
	//e[u
	tjs_int *arctan_table;
	tjs_int *sin_table;
	tjs_int *cos_table;
	tjs_int *tan_table;

	//p̑傫̐xB
	//angle_accuracy1024ȂA1024Ƃ݂ȂB
	tjs_int angle_accuracy;

	//E]̐xB
	//accuracy1024ȂA
	//E]l̍ől1023Aŏl-1023ƂȂB
	tjs_int sin_accuracy;

public:
	// constructor
	CTableHolder() {
		arctan_table = NULL;
		sin_table = NULL;
		cos_table = NULL;
		tan_table = NULL;

		angle_accuracy = 1024;
		sin_accuracy = 1024;
	}

	// destructor
	~CTableHolder() {
		clear();
	}

	// NA
	void clear();

	// 
	void createTable(tjs_int num, tjs_int sinacc);

	tjs_int getAccuracy() const {return this->angle_accuracy;}
	tjs_int getSinAccuracy() const {return this->sin_accuracy;}

	tjs_int arctan(tjs_int x, tjs_int y) const {return this->arctan_table[getAtanIndex(x, y)];}
	tjs_int arctan(tjs_int index) const {return this->arctan_table[index % this->angle_accuracy];}
	tjs_int sin(tjs_int index) const {return this->sin_table[index % this->angle_accuracy];}
	tjs_int cos(tjs_int index) const {return this->cos_table[index % this->angle_accuracy];}
	tjs_int tan(tjs_int index) const {return this->tan_table[index % this->angle_accuracy];}

	// tڃe[ũCfbNXl
	tjs_int getAtanIndex(tjs_int x, tjs_int y) const ;

	tjs_int getDistance(tjs_int x, tjs_int y) const {
		tjs_int rv = 0;
		if (x && y) {
			if (x < 0) x = -x;
			if (y < 0) x = -y;
			tjs_int atan = this->arctan(x, y);
//			if (x > y) {
				tjs_int cos = this->cos(atan);
				rv = (cos) ? (this->getSinAccuracy() * x / cos) : y;
/*			} else {
				tjs_int sin = this->sin(atan);
				rv = (sin) ? (this->getSinAccuracy() * y / sin) : x;
			}
*/		} else {
			rv = x ? x : y;
		}
		return rv;
	}

protected:

	// tڃe[u
	void createArctanTable();
	// e[u
	void createSinTable();
	void createTanTable() {}
	void createCosTable() {}
};

#endif _TVP_PLUGIN_TABLE_HOLDER_H_
