//---------------------------------------------------------------------------
#include "util_generic.h"
#include "KRObjIntfEx.h"

#include <lmcons.h>
#include <wchar.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "md5.h"
#include "GflSHA.h"
#include "TPMT19937ar.h"
#include "OSVersionInfo.h"

//---------------------------------------------------------------------------


static OSVersionInfo osversion;




//---------------------------------------------------------------------------
// {Iɂ͉ȂĂǁc
//---------------------------------------------------------------------------
void TVPCallBeforeV2LinkExit(void)
{
}

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// px̐x
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tGetAngleAccuracy)
{
	TP_REQ_NUM_PARAMS(0)
	TP_SET_RETURN_VALUE_INT(TableHolder->getAccuracy())
	return TJS_S_OK;
}

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// A]̐x
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tGetSinAccuracy)
{
	TP_REQ_NUM_PARAMS(0)
	TP_SET_RETURN_VALUE_INT(TableHolder->getSinAccuracy())
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// tڃe[u̍iCfbNXj擾܂B
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tAtanIndexFunction)
{
	TP_REQ_NUM_PARAMS(2)
	// W
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_SET_RETURN_VALUE_INT(TableHolder->getAtanIndex(x, y))
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// tڂ߂܂B
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tAtanFunction)
{
	TP_REQ_NUM_PARAMS(2)
	if (membername) return TJS_E_MEMBERNOTFOUND;
	// W
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_SET_RETURN_VALUE_INT(TableHolder->arctan(x, y))
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// ߂܂B
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSinFunction)
{
	TP_REQ_NUM_PARAMS(1)
	// ꂽtheta
	TP_GET_REQ_PARAM_INT(theta)
	TP_SET_RETURN_VALUE_INT(TableHolder->sin(theta))
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// ]߂܂B
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tCosFunction)
{
	TP_REQ_NUM_PARAMS(1)
	// ꂽtheta
	TP_GET_REQ_PARAM_INT(theta)
	TP_SET_RETURN_VALUE_INT(TableHolder->cos(theta))
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// w肳ꂽxŃe[uč쐬܂B
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tCreateTableFunction)
{
	TP_REQ_NUM_PARAMS(0)
	TP_GET_OPT_PARAM_INT(N, 1024)
	TP_GET_OPT_PARAM_INT(sN, 1024)
	TableHolder->createTable(N, sN);
	TP_SET_RETURN_VALUE_INT(0)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// _(x,y)̋Zo܂B
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tCalcDistanceFunction)
{
	TP_REQ_NUM_PARAMS(2)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)

	tjs_int atan = TableHolder->arctan(x, y);
	tjs_int cos  = TableHolder->cos(atan);
	tjs_int rv = (cos == 0) ? y : TableHolder->getSinAccuracy() * x / cos;

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// 2_Ԃ̋Zo܂B
//---------------------------------------------------------------------------
// Zo̎
static inline int fCalcDistance2PFunctionImpl(tjs_int x1, tjs_int y1, tjs_int x2, tjs_int y2)
{
	tjs_int x = x2 - x1;
	tjs_int y = y2 - y1;

	tjs_int rv = TableHolder->getDistance(x, y);

	return rv;
}

TVP_PLUGIN_FUNCCALL_DECL(tCalcDistance2PFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_INT(x1)
	TP_GET_REQ_PARAM_INT(y1)
	TP_GET_REQ_PARAM_INT(x2)
	TP_GET_REQ_PARAM_INT(y2)

	tjs_int rv = fCalcDistance2PFunctionImpl(x1, y1, x2, y2);
	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// 񂩃INebg񂩂MD5Zo
//---------------------------------------------------------------------------
// REQUIRE: dest ̗vf 16*2+1 = 33 ł邱ƁB
static void GetMD5HashImpl(const char * target, int target_len, char * dest)
{
	int i;

	md5_state_t state;
	md5_byte_t digest[16];
	char hex_output[16*2 + 1];

	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)target, target_len);
	md5_finish(&state, digest);
	for (i = 0; i < 16; ++i)
	{
	    sprintf(dest + i * 2, "%02x", digest[i]);
	}

	return;
}

TVP_PLUGIN_FUNCCALL_DECL(tMD5SummaryFunction)
{
	TP_REQ_NUM_PARAMS(1)

	char md5sum[16*2+1];

	// 
	if (TP_COND_PARAM_IS_STR) {
		TP_GET_REQ_PARAM_STR(workstr)

		// i[
		tjs_int narrow_len = workstr.GetNarrowStrLen();
		if (narrow_len == -1) TVPThrowExceptionMessage(TJS_W("̕ϊɎs܂"));

		char * narrow_str = new char [narrow_len + 1];

		// ϊ
		workstr.ToNarrowStr(narrow_str, narrow_len);

		// MD5Zo
		GetMD5HashImpl(narrow_str, narrow_len, md5sum);

		delete [] narrow_str;

		TP_SET_RETURN_VALUE_PTR(md5sum)

	// INebg
	} else if (TP_COND_PARAM_IS_OCT) {
		TP_GET_REQ_PARAM_OCT(voct)

		const tjs_uint8 * octdata = voct->GetData();
		tjs_uint chrlen = voct->GetLength();

		// MD5Zo
		GetMD5HashImpl(octdata, chrlen, md5sum);

		TP_SET_RETURN_VALUE_PTR(md5sum)

	} else {
		TVPThrowExceptionMessage(TJS_W("񂩃INebgw肵Ă"));
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// 񂩃INebg񂩂SHA1Zo
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSHA1SummaryFunction)
{
	TP_REQ_NUM_PARAMS(1)

	// 
	if (TP_COND_PARAM_IS_STR) {
		TP_GET_REQ_PARAM_STR(workstr)

		// i[
		tjs_int narrow_len = workstr.GetNarrowStrLen();
		if (narrow_len == -1) TVPThrowExceptionMessage(TJS_W("̕ϊɎs܂"));

		char * narrow_str = new char [narrow_len + 1];

		// ϊ
		workstr.ToNarrowStr(narrow_str, narrow_len);

		// SHA1Zo
		GflSHA1 sha1;
		sha1.Init();
		sha1.Load(narrow_str, narrow_len);
		sha1.Final();

		delete [] narrow_str;

		TP_SET_RETURN_VALUE_PTR(sha1.GetDigest().c_str())

	// INebg
	} else if (TP_COND_PARAM_IS_OCT) {
		TP_GET_REQ_PARAM_OCT(voct)

		const tjs_uint8 * octdata = voct->GetData();
		tjs_uint chrlen = voct->GetLength();

		// SHA1Zo
		GflSHA1 sha1;
		sha1.Init();
		sha1.Load(octdata, chrlen);
		sha1.Final();

		TP_SET_RETURN_VALUE_PTR(sha1.GetDigest().c_str())

	} else {
		TVPThrowExceptionMessage(TJS_W("񂩃INebgw肵Ă"));
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// 񂩃INebg񂩂SHA256Zo
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSHA256SummaryFunction)
{
	TP_REQ_NUM_PARAMS(1)

	// 
	if (TP_COND_PARAM_IS_STR) {
		TP_GET_REQ_PARAM_STR(workstr)

		// i[
		tjs_int narrow_len = workstr.GetNarrowStrLen();
		if (narrow_len == -1) TVPThrowExceptionMessage(TJS_W("̕ϊɎs܂"));

		char * narrow_str = new char [narrow_len + 1];

		// ϊ
		workstr.ToNarrowStr(narrow_str, narrow_len);

		// SHA256Zo
		GflSHA256 sha256;
		sha256.Init();
		sha256.Load(narrow_str, narrow_len);
		sha256.Final();

		delete [] narrow_str;

		TP_SET_RETURN_VALUE_PTR(sha256.GetDigest().c_str())

	// INebg
	} else if (TP_COND_PARAM_IS_OCT) {
		TP_GET_REQ_PARAM_OCT(voct)

		const tjs_uint8 * octdata = voct->GetData();
		tjs_uint chrlen = voct->GetLength();

		// SHA256Zo
		GflSHA256 sha256;
		sha256.Init();
		sha256.Load(octdata, chrlen);
		sha256.Final();

		TP_SET_RETURN_VALUE_PTR(sha256.GetDigest().c_str())

	} else {
		TVPThrowExceptionMessage(TJS_W("񂩃INebgw肵Ă"));
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// 16i_v
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tHexDumpFunction)
{
	TP_REQ_NUM_PARAMS(1)

	// 
	if (TP_COND_PARAM_IS_STR) {
		TP_GET_REQ_PARAM_STR(workstr)

		// i[
		tjs_int narrow_len = workstr.GetNarrowStrLen();
		if (narrow_len == -1) TVPThrowExceptionMessage(TJS_W("̕ϊɎs܂"));
		char * narrow_str = new char [narrow_len + 1];
		// ϊ
		workstr.ToNarrowStr(narrow_str, narrow_len);

		// INebgɕϊ
		tTJSVariantOctet * octdata = TJSAllocVariantOctet((tjs_uint8 *)narrow_str, narrow_len);

		// _v
		tTJSVariantString * str = TJSOctetToListString(octdata);

		// 悤Ȃ[
		TJSDeallocVariantOctet(octdata);
		delete [] narrow_str;

		if (result) {
			*result = str;
		}

	// INebg
	} else if (TP_COND_PARAM_IS_OCT) {
		TP_GET_REQ_PARAM_OCT(voct)

		tTJSVariantString * str = TJSOctetToListString(voct);

		if (result) {
			*result = str;
		}
	} else {
		TVPThrowExceptionMessage(TJS_W("񂩃INebgw肵Ă"));
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// zVbt
//---------------------------------------------------------------------------

TVP_PLUGIN_FUNCCALL_DECL(tArrayShuffleFunction)
{
	TP_REQ_NUM_PARAMS(0)

	iTJSDispatch2 * tmpArray = TJSCreateArrayObject();
	Array_FuncCall_assign(objthis, tmpArray);
	Array_FuncCall_clear(objthis);

	tjs_uint32 seed;
	/* set seed */ {
		tjs_uint8 randombits[16];
		TVPGetRandomBits128((void *)randombits);
		seed = *(tjs_uint32 *)(randombits + 12); //Kȏꏊ32bits
	}
	TPMersenneTwister mtgen(seed);

	tjs_int count = Array_PropGet_count(tmpArray);
	tjs_int cnt = count + 1;
	tTJSVariant val; // work

	// shuffle
	while (--cnt) {
		tjs_int idxget = mtgen.int31() % cnt;
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(tmpArray, Array, idxget, &val)
		Array_FuncCall_add(objthis, &val);
		Array_FuncCall_erase(tmpArray, idxget);
	}

	tmpArray->Release();

//	TP_SET_RETURN_VALUE_INT(count)
	TP_SET_RETURN_VALUE_OBJ(objthis)

	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// z񂩂L[zƒlz擾
//---------------------------------------------------------------------------

// dic: source dictionary
// array: elements (interleaved)
// ei: 1 : leave keys; 0 : leave values
static void removeDictionaryElementsImpl(iTJSDispatch2 * dic, iTJSDispatch2 * array, tjs_int ei)
{
	Array_FuncCall_assign(dic, array); \
	tjs_int cnt = Array_PropGet_count(array);

	if (cnt % 2) cnt--; // 肦ȂAیĂƂłЂƂB
	if ((ei != 0) && (ei != 1)) ei = 0; // 肦Ȃȉ

	while (cnt) {
		cnt -= 2;
		Array_FuncCall_erase(array, cnt + ei);
	}

	return;
}

#define F__GET_DICTIONARY_ELEM_IMPL(_obj, _ei) \
	if (result) { \
		iTJSDispatch2 * retArray = TJSCreateArrayObject(); \
		removeDictionaryElementsImpl(_obj, retArray, _ei); \
		TP_SET_RETURN_VALUE_OBJ(retArray) \
		retArray->Release(); \
	} \
	return TJS_S_OK;


TVP_PLUGIN_FUNCCALL_DECL(tDictionaryKeysFunction)
{
	TP_REQ_NUM_PARAMS(1)
	TP_GET_REQ_PARAM_OBJ(dic)
	F__GET_DICTIONARY_ELEM_IMPL(dic, 1)
}

TVP_PLUGIN_FUNCCALL_DECL(tDictionaryValuesFunction)
{
	TP_REQ_NUM_PARAMS(1)
	TP_GET_REQ_PARAM_OBJ(dic)
	F__GET_DICTIONARY_ELEM_IMPL(dic, 0)
}

TVP_PLUGIN_FUNCCALL_DECL(tDictionaryKeysStFunction)
{
	TP_REQ_NUM_PARAMS(0)
	F__GET_DICTIONARY_ELEM_IMPL(objthis, 1)
}

TVP_PLUGIN_FUNCCALL_DECL(tDictionaryValuesStFunction)
{
	TP_REQ_NUM_PARAMS(0)
	F__GET_DICTIONARY_ELEM_IMPL(objthis, 0)
}

#undef F__GET_DICTIONARY_ELEM_IMPL



//---------------------------------------------------------------------------
// zDump
//---------------------------------------------------------------------------
static void dumpDictionaryElements(
	iTJSDispatch2 * dic,
	tTJSString & kvdelim, 
	tTJSString & ppdelim, 
	tTJSString & out)
{
	iTJSDispatch2 * array = TJSCreateArrayObject();
	Array_FuncCall_assign(dic, array);
	tjs_int hcnt = Array_PropGet_count(array) / 2;
	tTJSVariant key, val;

	for (tjs_int i = 0; i < hcnt; i++) {
		if (i) out += ppdelim;
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(array, Array, 2*i, &key)
		TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALLIMPL(array, Array, 2*i+1, &val)
		out += key + kvdelim + val;
	}

	array->Release();

	return;
}

// static
TVP_PLUGIN_FUNCCALL_DECL(tDictionaryDumpStFunction)
{
	TP_REQ_NUM_PARAMS(2)
	TP_CHK_PARAM_MUST_STR
	TP_GET_REQ_PARAM_STR(kvdelim) // key-value delimiter
	TP_CHK_PARAM_MUST_STR
	TP_GET_REQ_PARAM_STR(ppdelim) // pair-pair delimiter

	tTJSString out;

	dumpDictionaryElements(objthis, kvdelim, ppdelim, out);

	TP_SET_RETURN_VALUE_VAR(out)
	return TJS_S_OK;
}

// 
TVP_PLUGIN_FUNCCALL_DECL(tDictionaryDumpFunction)
{
	TP_REQ_NUM_PARAMS(3)
	TP_GET_REQ_PARAM_OBJ(dic) // dictionary
	TP_CHK_PARAM_MUST_STR
	TP_GET_REQ_PARAM_STR(kvdelim) // key-value delimiter
	TP_CHK_PARAM_MUST_STR
	TP_GET_REQ_PARAM_STR(ppdelim) // pair-pair delimiter

	tTJSString out;

	dumpDictionaryElements(dic, kvdelim, ppdelim, out);

	TP_SET_RETURN_VALUE_VAR(out)
	return TJS_S_OK;
}

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// zɃftHglǉ
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDictionaryAddDefaultKeyFunction)
{
	TP_REQ_NUM_PARAMS(2)
	TP_CHK_PARAM_MUST_STR
	TP_GET_REQ_PARAM_STR(key)
	TP_GET_REQ_PARAM_VAR(val)

	tTJSVariant ico_result;
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// Dictionary IuWFNgiNX`j擾
	global->PropGet(TJS_MEMBERMUSTEXIST, TJS_W("Dictionary"), NULL, &ico_result, global);
	iTJSDispatch2 * classdef_Dictionary = ico_result.AsObjectNoAddRef();
	bool rv = false;

	if (classdef_Dictionary) {
		classdef_Dictionary->PropSet(TJS_MEMBERENSURE, key.c_str(), NULL, val, classdef_Dictionary);
		rv = true;
	} else {
		TVPThrowExceptionMessage(TJS_W("global.DictionaryNX݂܂"));
	}

	global->Release();

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// z񂩂ftHgl폜
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDictionaryDeleteDefaultKeyFunction)
{
	TP_REQ_NUM_PARAMS(1)
	TP_CHK_PARAM_MUST_STR
	TP_GET_REQ_PARAM_STR(key)

	tTJSVariant ico_result;
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// Dictionary IuWFNgiNX`j擾
	global->PropGet(TJS_MEMBERMUSTEXIST, TJS_W("Dictionary"), NULL, &ico_result, global);
	iTJSDispatch2 * classdef_Dictionary = ico_result.AsObjectNoAddRef();
	bool rv = false;

	if (classdef_Dictionary) {
		classdef_Dictionary->DeleteMember(0, key.c_str(), NULL, classdef_Dictionary);
		rv = true;
	} else {
		TVPThrowExceptionMessage(TJS_W("global.DictionaryNX݂܂"));
	}

	global->Release();

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// CPU feature
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSystemCPUFeatureFunction)
{
	TP_REQ_NUM_PARAMS(0)
	tjs_uint32 type = TVPGetCPUType() & TVP_CPU_FEATURE_MASK;
	TP_SET_RETURN_VALUE_INT(type)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// CPU vendor
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSystemCPUVendorFunction)
{
	TP_REQ_NUM_PARAMS(0)
	tjs_uint32 type = TVPGetCPUType() & TVP_CPU_VENDOR_MASK;
	TP_SET_RETURN_VALUE_INT(type)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// TempName
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSystemGetTempNameFunction)
{
	TP_REQ_NUM_PARAMS(0)
	TP_SET_RETURN_VALUE_PTR(TVPNormalizeStorageName(TVPGetTemporaryName()))
	return TJS_S_OK;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// memory status
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSystemGetMemoryStatusFunction)
{
	TP_REQ_NUM_PARAMS(0)

	if (result) {
		// z
		iTJSDispatch2 * dic = TJSCreateDictionaryObject();
		tTJSVariant wkval;

#define F__ADD_DIC_ELEM(_key, _val) wkval = (tTVInteger)_val; dic->PropSet(TJS_MEMBERENSURE, TJS_W(#_key), NULL, &wkval, dic);

		// Ƃ肠 GlobalMemoryStatusEx Ŏ擾Ă݂
		MEMORYSTATUSEX mstatEx;
		mstatEx.dwLength = sizeof(MEMORYSTATUSEX);
		if (GlobalMemoryStatusEx(&mstatEx)) {
			F__ADD_DIC_ELEM(MemoryLoad,           mstatEx.dwMemoryLoad)
			F__ADD_DIC_ELEM(TotalPhys,            mstatEx.ullTotalPhys)
			F__ADD_DIC_ELEM(AvailPhys,            mstatEx.ullAvailPhys)
			F__ADD_DIC_ELEM(TotalPageFile,        mstatEx.ullTotalPageFile)
			F__ADD_DIC_ELEM(AvailPageFile,        mstatEx.ullAvailPageFile)
			F__ADD_DIC_ELEM(TotalVirtual,         mstatEx.ullTotalVirtual)
			F__ADD_DIC_ELEM(AvailVirtual,         mstatEx.ullAvailVirtual)
			F__ADD_DIC_ELEM(AvailExtendedVirtual, mstatEx.ullAvailExtendedVirtual)

		// ߂Ȃ GlobalMemoryStatus
		} else {
			MEMORYSTATUS mstat;
			mstat.dwLength = sizeof(MEMORYSTATUS);
			GlobalMemoryStatus(&mstat);

			F__ADD_DIC_ELEM(MemoryLoad,           mstat.dwMemoryLoad)
			F__ADD_DIC_ELEM(TotalPhys,            mstat.dwTotalPhys)
			F__ADD_DIC_ELEM(AvailPhys,            mstat.dwAvailPhys)
			F__ADD_DIC_ELEM(TotalPageFile,        mstat.dwTotalPageFile)
			F__ADD_DIC_ELEM(AvailPageFile,        mstat.dwAvailPageFile)
			F__ADD_DIC_ELEM(TotalVirtual,         mstat.dwTotalVirtual)
			F__ADD_DIC_ELEM(AvailVirtual,         mstat.dwAvailVirtual)
		}

#undef  F__ADD_DIC_ELEM

		TP_SET_RETURN_VALUE_OBJ(dic)
		dic->Release();
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// OS version
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tSystemGetOSVersionInfoFunction)
{
	TP_REQ_NUM_PARAMS(0)

	tjs_int level = osversion.getInfo();

	if (result && (level > 0)) {
		// z
		iTJSDispatch2 * dic = TJSCreateDictionaryObject();
		tTJSVariant wkval;

#define F__ADD_DIC_ELEM_INT(_key, _val) wkval = (tTVInteger)_val; dic->PropSet(TJS_MEMBERENSURE, TJS_W(#_key), NULL, &wkval, dic);
#define F__ADD_DIC_ELEM_STR(_key, _val) wkval = _val; dic->PropSet(TJS_MEMBERENSURE, TJS_W(#_key), NULL, &wkval, dic);

		// std (Windows 9x, Me, NT 4.0 SP1..5
		if (level == 1) {
			OSVERSIONINFO & info = osversion.info;

			F__ADD_DIC_ELEM_INT(MajorVersion,     info.dwMajorVersion)
			F__ADD_DIC_ELEM_INT(MinorVersion,     info.dwMinorVersion)
			F__ADD_DIC_ELEM_INT(BuildNumber,      info.dwBuildNumber)
			F__ADD_DIC_ELEM_INT(PlatformId,       info.dwPlatformId)
			F__ADD_DIC_ELEM_STR(CSDVersion,       info.szCSDVersion)

		// Ex (Windows NT 4.0 SP6 or later)
		} else if (level == 2) {
			OSVERSIONINFOEX & info = osversion.infoEx;

			F__ADD_DIC_ELEM_INT(MajorVersion,     info.dwMajorVersion)
			F__ADD_DIC_ELEM_INT(MinorVersion,     info.dwMinorVersion)
			F__ADD_DIC_ELEM_INT(BuildNumber,      info.dwBuildNumber)
			F__ADD_DIC_ELEM_INT(PlatformId,       info.dwPlatformId)
			F__ADD_DIC_ELEM_STR(CSDVersion,       info.szCSDVersion)
			F__ADD_DIC_ELEM_INT(ServicePackMajor, info.wServicePackMajor)
			F__ADD_DIC_ELEM_INT(ServicePackMinor, info.wServicePackMinor)
			F__ADD_DIC_ELEM_INT(SuiteMask,        info.wSuiteMask)
			F__ADD_DIC_ELEM_INT(ProductType,      info.wProductType)
			F__ADD_DIC_ELEM_INT(Reserved,         info.wReserved)

		}

#undef  F__ADD_DIC_ELEM_INT
#undef  F__ADD_DIC_ELEM_STR

		TP_SET_RETURN_VALUE_OBJ(dic)
		dic->Release();
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------



