//---------------------------------------------------------------------------
#include "JuliaFunc.h"
//---------------------------------------------------------------------------

#define INIT_FT_ITR \
	tjs_real a = 0;	\
	tjs_real b = 0;	\
	tjs_real e = 0;	\
	\
	tjs_real add_re = 0;	\
	tjs_real add_im = 0;	\
	\
	const tjs_real threshold = 4.0;	\
	\
	if (ftype == FT_JULIA) {	\
		a = p_re;	\
		b = p_im;	\
		add_re = re;	\
		add_im = im;	\
	} else if (ftype == FT_MANDELBROT) {	\
		a = 0;	\
		b = 0;	\
		add_re = p_re;	\
		add_im = p_im;	\
	}




// ڂŔUԂ
// [vE𒴂ꍇ0Ԃ
// ȕ
tjs_int TPFUNCCALL GetJuliaIteration(
	// ^Cv
	tjs_int ftype,
	// fW
	tjs_real p_re,
	tjs_real p_im,
	// f萔
	tjs_real re,
	tjs_real im,
	// [vE
	tjs_int iteration_limit)
{
	tjs_int rv = 0;

INIT_FT_ITR

	// KKœKė~ƂB
	while ((e < threshold) && (rv++ < iteration_limit)) {
		tjs_real a2 = a * a - b * b + add_re; // 
		tjs_real b2 = 2.0 * a * b + add_im; // W
		e = a2 * a2 + b2 * b2; // Βl^2
		a = a2;
		b = b2;
	}

	if (rv > iteration_limit) rv = 0;

	return rv;
}



// ڂŔUԂ
// [vE𒴂ꍇ0Ԃ
// n
tjs_int TPFUNCCALL GetJuliaIterationPow(
	// ^Cv
	tjs_int ftype,
	// fW
	tjs_real p_re,
	tjs_real p_im,
	// f萔
	tjs_real re,
	tjs_real im,
	// ׂ搔i1ȏ̐j
	tjs_int pow,
	// [vE
	tjs_int iteration_limit)
{
	tjs_int rv = 0;

INIT_FT_ITR

	tjs_real c = a;
	tjs_real d = b;

	if (pow < 1) pow = 1;

	while ((e < threshold) && (rv++ < iteration_limit)) {
		tjs_real a2 = a;
		tjs_real b2 = b;
		// Q z^(n+1) = z^n * z
		for (tjs_int i = 1; i < pow; i++) {
			// (a+bi)(c+di) = (ac-bd) + (ad+bc)i
			a2 = a * c - b * d;
			b2 = a * d + b * c;
			a = a2;
			b = b2;
		}
		a2 += add_re; // 
		b2 += add_im; // W
		e = a2 * a2 + b2 * b2; // Βl
		c = a = a2;
		d = b = b2;
	}

	if (rv > iteration_limit) rv = 0;

	return rv;
}






// I
bool TPFUNCCALL CalcJuliaSet(
	// ^Cv
	tjs_int ftype,
	// fẄ
	tjs_real re_begin,
	tjs_real im_begin,
	tjs_real re_width,
	tjs_real im_width,
	// Zoʊi[z
	tjs_int * dest,
	// zTCY
	tjs_int array_width,
	tjs_int array_height,
	// f萔
	tjs_real re,
	tjs_real im,
	// ׂ搔i1ȏ̐j
	tjs_int pow,
	// [vE
	tjs_int iteration_limit)
{
	bool rv = false;

	if (array_width  <= 0) return rv;
	if (array_height <= 0) return rv;

	// TCY͑vł[H
	try {
		dest[array_height * array_width - 1];
	} catch(...) {
		throw; // OĂѓ
	}

	// sb`
	tjs_real xpitch = re_width / (tjs_real)array_width;
	tjs_real ypitch = im_width / (tjs_real)array_height;

	tjs_real b = im_begin;
	for (tjs_int y = 0; y < array_height; y++, b += ypitch) {
		tjs_real a = re_begin;
		for (tjs_int x = 0; x < array_width; x++, a += xpitch) {
			tjs_int idx = y * array_width + x;
			tjs_int itr =
				(pow == 2) ? 
				GetJuliaIteration(ftype, a, b, re, im, iteration_limit) : 
				GetJuliaIterationPow(ftype, a, b, re, im, pow, iteration_limit);
			dest[idx] = itr;
		}
	}
	rv = true;

	return rv;
}



// J[R[hz쐬
tjs_int TPFUNCCALL CreateColorCodeArray(
	tjs_int * src,
	tjs_uint32 * dest,
	tjs_int length,
	tTJSVariantClosure * func,
	tjs_int cacheLimit = 512)
{
	// ʃLbV
	bool withCache = false;
	tjs_int cacheSize = 0;

	if (cacheLimit > 0) {
		withCache = true;
		// őlTB̒l̓AEgB
		for (tjs_int i = 0; i < length; i++) {
			tjs_int val = src[i];
			if (cacheSize < val) cacheSize = val;
			if ((val > cacheLimit) || (val < 0)) {
				withCache = false;
				break;
			}
		}
	}

	static tjs_uint32 hint = 0;
	tTJSVariant result;
	tTJSVariant ** params = new tTJSVariant*[1];
	tTJSVariant pval;
	params[0] = &pval;

	// LbVg
	// FuncCall񐔂̂ŁAƑȂ邩B
	if (withCache) {
		cacheSize++;
		// LbV쐬
		tjs_uint32 * cache = new tjs_uint32[cacheSize];
		for (tjs_int i = 0; i < cacheSize; i++) {
			pval = i;
			try {
				tjs_error errcode = 0;
				if (TJS_FAILED(errcode = func->FuncCall(0, NULL, &hint, &result, 1, params, NULL))) {
					delete[] params;
					TVPThrowExceptionMessage(TJS_W("TVP Plugin: invoking of callback() failed. ErrorCode=%1."),
						(tTJSVariant)(errcode));
				}
			} catch (...) {
				delete[] params;
				throw;
			}
			cache[i] = 0xFF000000 | (tTVInteger)result;
		}
		// LbV𗘗p
		for (tjs_int i = 0; i < length; i++) {
			dest[i] = cache[src[i]];
		}
		delete[] cache;

	// LbVg킸Aʂ
	} else {
		for (tjs_int i = 0; i < length; i++) {
			pval = src[i];
			try {
				tjs_error errcode = 0;
				if (TJS_FAILED(errcode = func->FuncCall(0, NULL, &hint, &result, 1, params, NULL))) {
					delete[] params;
					TVPThrowExceptionMessage(TJS_W("TVP Plugin: invoking of callback() failed. ErrorCode=%1."),
						(tTJSVariant)(errcode));
				}
			} catch (...) {
				delete[] params;
				throw;
			}
			dest[i] = 0xFF000000 | (tTVInteger)result;
		}
	}

	delete[] params;

	return 0;
}


// tN^`
tjs_int TPFUNCCALL DrawFractalImpl(
	iTJSDispatch2  * layer,	// `ΏۃC
	tTJSVariantClosure * func,	// J[R[hZo֐
	tjs_int * juliaset,	// J[R[hZoʊi[z
	tjs_int left, //	`݈ʒu
	tjs_int top, //	`݈ʒu
	tjs_int width, //	`݃TCY
	tjs_int height) //	`݃TCY
{
	tjs_int rv = 1;
	tjs_int array_size = width * height;
	tjs_uint32 * colorset = new tjs_uint32[array_size]; // J[R[hz


	// C
	LayerInfo info;
	info.setForWrite(layer);

	CreateColorCodeArray(juliaset, colorset, array_size, func);
	for (tjs_int y = 0; y < height; y++) {
		tjs_int yoffset = (height - y - 1) * width;	// ㉺ЂԂ܂
		for (tjs_int x = 0; x < width; x++) {
			LayerBuffer_setPixel(left + x, top + y, colorset[yoffset + x], &info);
		}
	}

	delete[] colorset; // Y

	return rv;
}


