#ifndef _TVP_PLUGIN_LAYER_INTERFACE_H_
#define _TVP_PLUGIN_LAYER_INTERFACE_H_

#include "TVPPlugIn.h"
#include "ComplexRect.h"

// 
#include "KRLayerIntfEx.h"

// Ǝg
const tjs_int Layer_PropGetEx_clipRect(iTJSDispatch2 * layer, tTVPRect * dest);

// function Layer.update
void Layer_FuncCall_update(iTJSDispatch2 * layer);

// function Layer.colorRect
void Layer_FuncCall_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params);


// gg̃C[Wobt@
// قƂǍ\̈
BEGIN_CLASSDEF(ImageBufferInfo)
public:
	tjs_int width;	// image buffer width
	tjs_int height;	// image buffer height

	const tjs_uint8 * bufferptr;	// image buffer ptr
	tjs_int bufferpitch;	// image buffer pitch in byte

public:
	// RXgN^
	thisclass()
	{
	}

	// w肵p[^ŏ
	inline virtual void init(const tjs_uint8 * ptr, tjs_int pitch, tjs_int w, tjs_int h)
	{
		this->bufferptr = ptr;
		this->bufferpitch = pitch;
		this->width = w;
		this->height = h;
		return;
	}

	// w肵Ww|C^
	inline virtual tjs_uint32 * getBufferPtr(tjs_int x, tjs_int y) const
	{
		return (tjs_uint32 *)(this->bufferptr + y * this->bufferpitch + x * sizeof(tjs_uint32));
	}

END_CLASSDEF


// C
// قƂǍ\̈
BEGIN_CLASSDEF_INHERIT(LayerInfo, ImageBufferInfo)
public:
	tTVPLayerType type;
	tTVPDrawFace face;
	iTJSDispatch2 * dispatcher;
	tTVPRect * clipRect;
	tTVPRect * drawRect;

	// province image
	const tjs_uint8 * bufferptrPv;
	tjs_int bufferpitchPv;	// in byte

public:
	thisclass() : inherited()
	{
		clipRect = new tTVPRect();
		drawRect = new tTVPRect();
	}

	virtual ~LayerInfo()
	{
		delete clipRect;
		delete drawRect;
	}

	// main image
	// ǂݍݐp
	virtual void setForRead(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptr = Layer_PropGet_mainImageBuffer(layer);
		bufferpitch = Layer_PropGet_mainImageBufferPitch(layer);
	}
	// ݗp
	virtual void setForWrite(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptr = Layer_PropGet_mainImageBufferForWrite(layer);
		bufferpitch = Layer_PropGet_mainImageBufferPitch(layer);
	}

	// province image
	// ǂݍݐp
	virtual void setForReadPv(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptrPv = Layer_PropGet_provinceImageBuffer(layer);
		bufferpitchPv = Layer_PropGet_provinceImageBufferPitch(layer);
	}
	// ݗp
	virtual void setForWritePv(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptrPv = Layer_PropGet_provinceImageBufferForWrite(layer);
		bufferpitchPv = Layer_PropGet_provinceImageBufferPitch(layer);
	}

	virtual void setCommon(iTJSDispatch2 * layer)
	{
		dispatcher = layer;
		face   = Layer_PropGet_face(layer);
		type   = Layer_PropGet_type(layer);

		width  = Layer_PropGet_imageWidth(layer);
		height = Layer_PropGet_imageHeight(layer);

		Layer_PropGetEx_clipRect(layer, clipRect);

		drawRect->left = (clipRect->left < 0) ? 0 : clipRect->left;
		drawRect->top  = (clipRect->top  < 0) ? 0 : clipRect->top;
		drawRect->right  = (clipRect->right  >= width)  ? (width - 1)  : clipRect->right;
		drawRect->bottom = (clipRect->bottom >= height) ? (height - 1) : clipRect->bottom;
/*
		drawRect->left   = clipRect->left;
		drawRect->top    = clipRect->top;
		drawRect->right  = clipRect->right;
		drawRect->bottom = clipRect->bottom;
*/	}


	inline virtual bool isDrawRegion(tjs_int x, tjs_int y) const
	{
		const tTVPRect * const draw = this->drawRect;
		return ((x >= draw->left) && (y >= draw->top) && (x <= draw->right) && (y <= draw->bottom));
		//return ((x >= 0) && (y >= 0) && (x < width) && (y < height));
	}

	inline virtual tjs_uint32 * getBufferPtr_StrictDraw(tjs_int x, tjs_int y) const
	{
		tjs_uint32 * p = NULL;
		if (this->isDrawRegion(x, y)) {
			p = this->getBufferPtr(x, y);
		}
		return p;
	}

END_CLASSDEF



// function Layer.update (useful)
void Layer_FuncCall_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h);


#endif _TVP_PLUGIN_LAYER_INTERFACE_H_

