#ifndef _TVP_PLUGIN_PARAMETRIC_CURVE_FUNC_H_
#define _TVP_PLUGIN_PARAMETRIC_CURVE_FUNC_H_

#include "TVPPlugIn.h"


//Ȑ^Cv
#define PCURVE_TYPE_STUB 0
#define PCURVE_TYPE_KAG3_SPLINE 1
#define PCURVE_TYPE_CUBIC_SPLINE_OPEN  2
#define PCURVE_TYPE_CUBIC_SPLINE_CLOSE 3
#define PCURVE_TYPE_BEZIER_OPEN 4
#define PCURVE_TYPE_LAGRANGE_INTERPOLATION 5
#define PCURVE_TYPE_CHAIKIN_OPEN 6
#define PCURVE_TYPE_CHAIKIN_OPEN_PST 7
#define PCURVE_TYPE_CHAIKIN_CLOSE 8



#define SUPER_GET_COORDS_IIRR_IMPL \
	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_real & cx, tjs_real & cy) \
	{ \
		return inherited::getCoord(index, subindex, cx, cy); \
	}
#define SUPER_GET_COORDS_IRR_IMPL \
	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy) \
	{ \
		return inherited::getCoord(dindex, cx, cy); \
	}
#define SUPER_GET_COORDS_IIII_IMPL \
	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_int & cx, tjs_int & cy) \
	{ \
		return inherited::getCoord(index, subindex, cx, cy); \
	}
#define SUPER_GET_COORDS_III_IMPL \
	virtual bool getCoord(tjs_int dindex, tjs_int & cx, tjs_int & cy) \
	{ \
		return inherited::getCoord(dindex, cx, cy); \
	}


#define DEF_REQUIRED_PARAM_FUNC(_n) virtual tjs_int getRequiredPoints() const { return _n; }
#define DEF_LIMIT_PARAM_FUNC(_n)    virtual tjs_int getLimitPoints() const { return _n; }


#define DELETE_ARRAY(_p) \
	if (_p) { \
		delete[] _p; \
		_p = NULL; \
	}


// C^[tF[X
BEGIN_CLASSDEF(ParametricCurveTracer)

protected:
	bool active;
	tjs_int * xpath; // _ (ref)
	tjs_int * ypath;
	tjs_int numPoints; // _
	tjs_int accuracy; // `搸xiԂ̕j
	tjs_int numNodes;	// `m[h

public:
	thisclass();

	virtual ~ParametricCurveTracer();

	// getter
	inline tjs_int * getXPath()   const { return xpath; }
	inline tjs_int * getYPath()   const { return ypath; }
	inline tjs_int getNumPoints() const { return numPoints; }
	inline tjs_int getAccuracy()  const { return accuracy; }

	inline bool isActive() const { return active; }

	// 
	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac) = 0;
	// 
	virtual void clear() = 0;


	// WZo
	// ^ij
	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy) = 0;

	// ^
	virtual bool getCoord(tjs_int dindex, tjs_int & cx, tjs_int & cy)
	{
		tjs_real rx, ry;
		bool rv = getCoord(dindex, rx, ry);
		if (rv) {
			cx = (tjs_int)rx;
			cy = (tjs_int)ry;
		}
		return rv;
	}

	// TuCfbNX^
	// ^
	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_real & cx, tjs_real & cy)
	{
		tjs_int dindex = index * accuracy + subindex;
		return getCoord(dindex, cx, cy);
	}

	// ^
	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_int & cx, tjs_int & cy)
	{
		tjs_int dindex = index * accuracy + subindex;
		return getCoord(dindex, cx, cy);
	}

	// KvȐ_iKvɉăI[o[Chj
	DEF_REQUIRED_PARAM_FUNC(3)

	// \ȍő吧_iKvɉăI[o[Chj
	// ̏ꍇ͕̒lԂ
	DEF_LIMIT_PARAM_FUNC(-1)


protected:
	void activate()
	{
		active = true;
	}

	void inactivate()
	{
		active = false;
	}

END_CLASSDEF





// X^u
// xpath, ypath̒l̂܂ܕԂAw^Y
BEGIN_CLASSDEF_INHERIT(StubCurveTracer, ParametricCurveTracer)

public:
	// RXgN^
	thisclass() : inherited()
	{
		xpath = ypath = NULL;
		numPoints = accuracy = 0;
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~StubCurveTracer()
	{
	}

	DEF_REQUIRED_PARAM_FUNC(2)

	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

	virtual void clear();

	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy)
	{
		bool rv = false;
		if (0 <= dindex && dindex < numPoints) {
			cx = this->xpath[dindex];
			cy = this->ypath[dindex];
			rv = true;
		}
		return rv;
	}
	SUPER_GET_COORDS_III_IMPL

	// TuCfbNX^
	// ^
	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_real & cx, tjs_real & cy)
	{
		return getCoord(index + subindex, cx, cy);
	}

	// ^
	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_int & cx, tjs_int & cy)
	{
		return getCoord(index + subindex, cx, cy);
	}

END_CLASSDEF





// KAG3 Impl.
BEGIN_CLASSDEF_INHERIT(KAG3SplineTracer, ParametricCurveTracer)

protected:
	tjs_real * zx;  // XvC[N
	tjs_real * zy;

	bool active;

public:

	thisclass() : inherited()
	{
		zx = zy = NULL;
		xpath = ypath = NULL;
		numPoints = accuracy = 0;
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~KAG3SplineTracer()
	{
		releaseMem();
	}

	DEF_REQUIRED_PARAM_FUNC(3)

	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

	virtual void clear();

	// WZo
	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy)
	{
		return this->getCoord(dindex / accuracy, dindex % accuracy, cx, cy);
	}

	virtual bool getCoord(tjs_int index, tjs_int subindex, tjs_real & cx, tjs_real & cy);
	SUPER_GET_COORDS_III_IMPL
	SUPER_GET_COORDS_IIII_IMPL

protected:
	virtual void releaseMem();

	virtual void allocMem();

	// XvCԂɕKvȃ[NvZ
	virtual bool makeTable();

END_CLASSDEF






// O JXvC
BEGIN_CLASSDEF_INHERIT(CubicSplineTracerOpen, ParametricCurveTracer)

protected:
	tjs_real * pz;	//  (0.0`1.0)
	tjs_real * za;
	tjs_real * zb;
	tjs_int * nodeIndex;	// pini[⊮_CfbNX] = pzCfbNXj

public:
	// RXgN^
	thisclass() : inherited()
	{
		pz = za = zb = NULL;
		nodeIndex = NULL;
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~CubicSplineTracerOpen()
	{
		releaseMem();
	}

	DEF_REQUIRED_PARAM_FUNC(2)

	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

	virtual void clear();

	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy);
	SUPER_GET_COORDS_III_IMPL
	SUPER_GET_COORDS_IIII_IMPL
	SUPER_GET_COORDS_IIRR_IMPL

protected:
	virtual void releaseMem();

	virtual void allocMem();

	virtual void makeTable();

	virtual void internalMakeTable(tjs_real * x, tjs_int * y, tjs_real * z);

	virtual void createNodeIndex();

	virtual tjs_real internalGetCoord(tjs_int index, tjs_int * y, tjs_real * z);

END_CLASSDEF



// O XvC
BEGIN_CLASSDEF_INHERIT(CubicSplineTracerClose, CubicSplineTracerOpen)

public:
	// RXgN^
	thisclass() : inherited()
	{
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~CubicSplineTracerClose()
	{
		releaseMem();
	}

	DEF_REQUIRED_PARAM_FUNC(3)

	// override
	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

protected:

	// override
	virtual void internalMakeTable(tjs_real * x, tjs_int * y, tjs_real * z);

END_CLASSDEF




// xWGȐ
BEGIN_CLASSDEF_INHERIT(BezierTracerOpen, ParametricCurveTracer)

protected:

public:
	// RXgN^
	thisclass() : inherited()
	{
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~BezierTracerOpen()
	{
	}

	DEF_REQUIRED_PARAM_FUNC(2)
//	DEF_LIMIT_PARAM_FUNC(13)

	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

	virtual void clear();

	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy);
	SUPER_GET_COORDS_III_IMPL
	SUPER_GET_COORDS_IIII_IMPL
	SUPER_GET_COORDS_IIRR_IMPL

protected:

	static tjs_real * getCombinationCoeffs(tjs_int n);
	static tjs_real getCombinationCoeffOverX(tjs_int n, tjs_int r, tjs_int next_n, tjs_int old_nCr);

END_CLASSDEF




// OWԋȐ
// SœKĂȂxAƁB
BEGIN_CLASSDEF_INHERIT(LagrangeCurveTracer, CubicSplineTracerOpen)

public:
	// RXgN^
	thisclass() : inherited()
	{
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~LagrangeCurveTracer()
	{
		releaseMem();
	}

	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy);
	SUPER_GET_COORDS_III_IMPL
	SUPER_GET_COORDS_IIII_IMPL
	SUPER_GET_COORDS_IIRR_IMPL

protected:

	virtual void makeTable();

//	virtual void internalMakeTable(tjs_real * x, tjs_int * y, tjs_real * z);

	virtual tjs_real internalGetCoord(tjs_int index, tjs_int * y);

END_CLASSDEF




// `CLBXvCJȐ
BEGIN_CLASSDEF_INHERIT(ChaikinTracerOpen, ParametricCurveTracer)

protected:
	tjs_real * pz;	//  (0.0`1.0)
	tjs_int * xpath2;	// _W
	tjs_int * ypath2;
	tjs_int * nodeIndex;	// p
	tjs_int numPoints2;

public:
	// RXgN^
	thisclass() : inherited()
	{
		pz = NULL;
		xpath2 = ypath2 = NULL;
		nodeIndex = NULL;
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~ChaikinTracerOpen()
	{
	}

	DEF_REQUIRED_PARAM_FUNC(4)

	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

	virtual void makeTable();

	virtual void clear();

	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy);
	SUPER_GET_COORDS_III_IMPL
	SUPER_GET_COORDS_IIII_IMPL
	SUPER_GET_COORDS_IIRR_IMPL

protected:
	virtual void releaseMem();

	virtual void allocMem();

	virtual void createNodeIndex();

END_CLASSDEF



// `CLBXvCJȐin_ƏI_ʂj
// PST: pass the starting point and the terminal
BEGIN_CLASSDEF_INHERIT(ChaikinTracerOpenPST, ChaikinTracerOpen)

public:
	// RXgN^
	thisclass() : inherited()
	{
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac) : inherited(xp, yp, n, ac)
	{
	}

	virtual ~ChaikinTracerOpenPST()
	{
	}

	virtual void makeTable();

END_CLASSDEF



// `CLBXvCȐ
BEGIN_CLASSDEF_INHERIT(ChaikinTracerClose, ChaikinTracerOpen)

public:
	// RXgN^
	thisclass() : inherited()
	{
	}

	thisclass(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac)
	{
		thisclass();
		init(xp, yp, n, ac);
	}

	virtual ~ChaikinTracerClose()
	{
	}

	virtual void init(tjs_int * xp, tjs_int * yp, tjs_int n, tjs_int ac);

	virtual void makeTable();
/*
	virtual bool getCoord(tjs_int dindex, tjs_real & cx, tjs_real & cy);
	SUPER_GET_COORDS_III_IMPL
	SUPER_GET_COORDS_IIII_IMPL
	SUPER_GET_COORDS_IIRR_IMPL
*/
protected:

	virtual void allocMem();

END_CLASSDEF






// get instance
ParametricCurveTracer * GetParametricCurveTracer(tjs_int type);
// free instance
void FreeParametricCurveTracer(ParametricCurveTracer * curve);


#undef SUPER_GET_COORDS_III_IMPL
#undef SUPER_GET_COORDS_IIII_IMPL
#undef SUPER_GET_COORDS_IRR_IMPL
#undef SUPER_GET_COORDS_IIRR_IMPL


#endif _TVP_PLUGIN_PARAMETRIC_CURVE_FUNC_H_

