/*
* yCg
* IWiR[hF
* http://www2.starcat.ne.jp/~fussy/algo/algo3-2.htm
*
*/

#include "GraphFunc.h"
#include "TPGraphic.h"
#include "LayerBufferImpl.h"
#include "PaintFunc.h"

//#include <math.h>

// XVtO
extern bool TPFAutoUpdateMode;



// yCgp

SeedFillBuffer::SeedFillBuffer(tjs_int n, LayerInfo * layer)
{
	numInfo = n;
	if (n <= 0) {
		info = NULL;
		drawnBuffer = NULL;

		idxStart = idxEnd = -1;
	} else {
		info = new SeedFillInfo*[n];
		for (int i = 0; i < n; i++) {
			info[i] = new SeedFillInfo();
		}
		idxStart = 0;
		idxEnd   = n > 1 ? 1 : 0;

		// ȂǃCC[WTCYm
		// {͕`Nbv̈敪ł񂾂ǁc
		this->layer = layer;
		const tjs_int siz = layer->width * layer->height;
		drawnBuffer = new tjs_uint8[siz];
		// 0ŏ
		tjs_uint8 * const wkdb = drawnBuffer;
		for (tjs_int i = 0; i < siz; i++) {
			wkdb[i] = 0;
		}
	}
}

SeedFillBuffer::~SeedFillBuffer()
{
	// 
	if (info != NULL) {
		for (int i = 0; i < numInfo; i++) {
			delete info[i];
		}
		delete[] info;
	}

	if (drawnBuffer != NULL) {
		delete[] drawnBuffer;
	}
}


bool SeedFillBuffer::incStart()
{
	bool rv = (++idxStart < count());
	if (!rv) idxStart--;
	return rv;
}

bool SeedFillBuffer::incEnd()
{
	bool rv = (++idxEnd < count());
	if (!rv) idxEnd--;
	return rv;
}


// ͈̓`FbNȂ[
bool SeedFillBuffer::isDrawn(tjs_int x, tjs_int y) const
{
	return (this->drawnBuffer[y * this->layer->width + x]);
}

// ͈̓`FbNȂ[
void SeedFillBuffer::setDrawn(tjs_int x, tjs_int y, tjs_int w)
{
	tjs_uint8 * const db = this->drawnBuffer;
	const tjs_int width = this->layer->width;
	for (tjs_int i = x; i < w + x; i++) {
		db[y * width + i] = 1;
	}
}




// Main image
static void TPFUNCCALL scanSeedLine(
	const LayerInfo * layer,
	LayerInfo * pvLayer,
	SeedFillBuffer * seed,
	tjs_int lx,
	tjs_int rx,
	tjs_int y,
	tjs_int oy,
	tjs_uint32 col,
	tjs_int ref = TP_PAINT_REF_OPAQUE)
{
	tjs_uint8  pvCol = 0;
	tjs_uint32 colMask = 0;
	tjs_uint32 baseCol = 0;

#define F__SEED_SCAN_LINE_FNL \
			seed->end()->rx = lx - 1;	\
			seed->end()->y = y;	\
			seed->end()->oy = oy;	\
			if (!seed->incEnd()) {	\
				seed->resetEnd();	\
			}

	switch (ref) {
	case TP_PAINT_REF_ALPHA:
		while (lx <= rx) {
			// ÄF΂
			for (; lx < rx ; lx++) {
				if (LayerBuffer_getPixel_NoCheck(lx, y, layer) == col) break;
			}
			if (LayerBuffer_getPixel_NoCheck(lx, y, layer) != col) break;
			seed->end()->lx = lx;

			// ÄF΂
			for (; lx <= rx; lx++) {
				if (LayerBuffer_getPixel_NoCheck(lx, y, layer) != col) break;
			}
			F__SEED_SCAN_LINE_FNL
		}
		break;

	case TP_PAINT_REF_OPAQUE:
	case TP_PAINT_REF_MASK:
		colMask = (ref == TP_PAINT_REF_MASK) ? 0xff000000 : 0x00ffffff;
		baseCol = col;
		while (lx <= rx) {
			// ÄF΂
			for (; lx < rx ; lx++) {
				if ((LayerBuffer_getPixel_NoCheck(lx, y, layer) & colMask) == baseCol) break;
			}
			if ((LayerBuffer_getPixel_NoCheck(lx, y, layer) & colMask) != baseCol) break;
			seed->end()->lx = lx;

			// ÄF΂
			for (; lx <= rx; lx++) {
				if ((LayerBuffer_getPixel_NoCheck(lx, y, layer) & colMask) != baseCol) break;
			}
			F__SEED_SCAN_LINE_FNL
		}
		break;

	case TP_PAINT_REF_PROVINCE:
		pvCol = (tjs_uint8)col;
		while (lx <= rx) {
			// ÄF΂
			for (; lx < rx ; lx++) {
				if (LayerBuffer_getPixelPv_NoCheck(lx, y, pvLayer) == pvCol) break;
			}
			if (LayerBuffer_getPixelPv_NoCheck(lx, y, pvLayer) != pvCol) break;
			seed->end()->lx = lx;

			// ÄF΂
			for (; lx <= rx; lx++) {
				if (LayerBuffer_getPixelPv_NoCheck(lx, y, pvLayer) != pvCol) break;
			}
			F__SEED_SCAN_LINE_FNL
		}
		break;

	default:
		break;

	} //end sw.
#undef F__SEED_SCAN_LINE_FNL

	return;
}


tjs_int TPFUNCCALL Layer_paintImpl(
	LayerInfo * layer,
	LayerInfo * pvLayer,
	tjs_int x,
	tjs_int y,
	tjs_uint32 paint_color,
	tjs_int opa,
	tjs_int ref = TP_PAINT_REF_OPAQUE)
{
	const tTVPRect * const draw = layer->drawRect;
	tjs_int clipWidth  = draw->get_width();
	tjs_int clipHeight = draw->get_height();

	// no action
	if (
		// face  dfOpaque ̏ꍇ̂ݕ`\
//		(layer->face != dfOpaque) ||
		(x < draw->left) ||
		(y < draw->top)  ||
		(x > draw->right)  ||
		(y > draw->bottom) ||
		(clipWidth  <= 0) ||
		(clipHeight <= 0))
		return 0;

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	SeedFillBuffer * seed = new SeedFillBuffer(clipHeight + 2, layer);

	seed->start()->lx = seed->start()->rx = x;
	seed->start()->y  = seed->start()->oy = y;
	tjs_uint32 col   = 0;
	tjs_uint8  pvCol = 0;
	tjs_uint32 prCol = 0;
	tjs_uint32 colMask = 0;


#define F__SEED_FILL_INT	\
		tjs_int lx = seed->start()->lx;	\
		tjs_int rx = seed->start()->rx;	\
		tjs_int uy = seed->start()->y;	\
		tjs_int dy = seed->start()->y;	\
		tjs_int oy = seed->start()->oy;	\
	\
		tjs_int lxsav = lx - 1;	\
		tjs_int rxsav = rx + 1;	\
	\
		if (!seed->incStart()) {	\
			seed->resetStart();	\
		}

#define F__SEED_FILL_FNL	\
		rx--;	\
		lx++;	\
	\
		/* lx-rx̐` */	\
		trv = Layer_drawHorizontalLineImpl(layer, lx, uy, rx - lx + 1, paint_color, opa);	\
		F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv) \
		/* ܂ */	\
		seed->setDrawn(lx, uy, rx - lx + 1);	\
	\
		/* ^̃XLC𑖍 */	\
		if (--uy >= draw->top) {	\
			if (uy == oy) {	\
				scanSeedLine(layer, pvLayer, seed, lx, lxsav, uy, uy + 1, col, ref);	\
				scanSeedLine(layer, pvLayer, seed, rxsav, rx, uy, uy + 1, col, ref);	\
			} else {	\
				scanSeedLine(layer, pvLayer, seed, lx, rx, uy, uy + 1, col, ref);	\
			}	\
		}	\
	\
		/* ^̃XLC𑖍 */	\
		if (++dy <= draw->bottom) {	\
			if (dy == oy) {	\
				scanSeedLine(layer, pvLayer, seed, lx, lxsav, dy, dy - 1, col, ref);	\
				scanSeedLine(layer, pvLayer, seed, rxsav, rx, dy, dy - 1, col, ref);	\
			} else {	\
				scanSeedLine(layer, pvLayer, seed, lx, rx, dy, dy - 1, col, ref);	\
			}	\
		}

	tjs_int trv;
	switch (ref) {
	case TP_PAINT_REF_ALPHA:
		col   = LayerBuffer_getPixel_NoCheck(x, y, layer);
		prCol = paint_color;
		do {
			F__SEED_FILL_INT
			// ς̃V[hȂ疳
			if (seed->isDrawn(lx, uy)) continue;
			// E̋ET
			while ((rx <= draw->right) && (LayerBuffer_getPixel_NoCheck(++rx, uy, layer) == col));
			// ̋ET
			while ((lx > draw->left)  && (LayerBuffer_getPixel_NoCheck(--lx, uy, layer) == col));
			F__SEED_FILL_FNL
		} while (seed->start() != seed->end());
		break;

	case TP_PAINT_REF_MASK:
	case TP_PAINT_REF_OPAQUE:
		colMask = (ref == TP_PAINT_REF_MASK) ? 0xff000000 : 0x00ffffff;
		col   = LayerBuffer_getPixel_NoCheck(x, y, layer) & colMask;
		prCol = paint_color & colMask;

		do {
			F__SEED_FILL_INT
			// ς̃V[hȂ疳
			if (seed->isDrawn(lx, uy)) continue;
			// E̋ET
			while ((rx < draw->right) && ((LayerBuffer_getPixel_NoCheck(++rx, uy, layer) & colMask) == col));
			// ̋ET
			while ((lx > draw->left)  && ((LayerBuffer_getPixel_NoCheck(--lx, uy, layer) & colMask) == col));
			F__SEED_FILL_FNL
		} while (seed->start() != seed->end());
		break;

	case TP_PAINT_REF_PROVINCE:
		pvCol = LayerBuffer_getPixelPv_NoCheck(x, y, pvLayer);
		col = pvCol;

		do {
			F__SEED_FILL_INT
			// ς̃V[hȂ疳
			if (seed->isDrawn(lx, uy)) continue;
			// E̋ET
			while ((rx < draw->right) && (LayerBuffer_getPixelPv_NoCheck(++rx, uy, pvLayer) == pvCol));
			// ̋ET
			while ((lx > draw->left)  && (LayerBuffer_getPixelPv_NoCheck(--lx, uy, pvLayer) == pvCol));
			F__SEED_FILL_FNL
		} while (seed->start() != seed->end());
		break;

	default:
		break;
	} // end sw.

#undef F__SEED_FILL_INT
#undef F__SEED_FILL_FNL

	delete seed;

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, draw->left, draw->top, draw->get_width(), draw->get_height());
	}

	return rv;
}



