
# o[X^C֐̊ěWZo邽߂̃XNvgB
# xWG֌W̃\[X肷B
# 


bezierSource();

exit();


foreach my $i (1..13) {
	my $t = factorial($i);
	print "$i! : $t\n";
}




sub factorial {
	my ($x) = @_;
	my $rv = 1;

	foreach my $i (1..$x) {
		$rv *= $i;
	}

	return $rv;
}

sub combination {
	my ($n, $r) = @_;
	my $rv;
	if ($r >= $n || $r <= 0) {
		$rv = 1;
	} elsif ($n <= 13) {
		$rv = factorial($n) / (factorial($r) * factorial($n-$r));
	} else {
		$rv = combinationOver13($n, $r, 14, combination(13,$r));
	}
	return $rv;
}

sub combinationOver13 {
	my ($n, $r, $bn, $ncr) = @_;

	if ($bn > $n) {
		return $ncr;
	}

	my $rv;

	if ($r >= $bn || $r <= 0) {
		$ncr = 1;
	} else {
		$ncr = $ncr * $bn / ($bn - $r);
	}

 	$rv = combinationOver13($n, $r, $bn + 1, $ncr);

	return $rv;
}


sub bezierSource {
	my ($n) = @ARGV;
	my $prx = 'coeffs';
	my $out = << "END";
// generated by $0
tjs_real * BezierTracerOpen::getCombinationCoeffs(tjs_int n)
{
	const tjs_int nMax = $n;
	static tjs_real * coeffsLarge = NULL;
END
	my @varlist = ();

	foreach my $m (0..$n) {
		my $nn = $m + 1;
		my $varname = sprintf("${prx}_%02d", $m);
		$out .= "\tstatic tjs_real $varname\[$nn\] = { ";
		my @ps = ();
		foreach my $i (0..$m) {
			my $ncr = combination($m, $i);
			push @ps, "${ncr}";
		}
		$out .= join(', ', @ps) . " };\n";
		push @varlist, $varname;
	}

	my $nn = $n + 1;
	my $vl = join(', ', @varlist);
	$out .= << "END";
	static tjs_real *${prx}[nMax+1] = { $vl };
	tjs_real * rv = NULL;
	if (n > 0 && n <= nMax) {
		rv = coeffs[n];
	} else if (n > nMax) {
		if (coeffsLarge) delete coeffsLarge;
		coeffsLarge = new tjs_real[n+1];
		tjs_real * prevCoeffs = coeffs[nMax];
		coeffsLarge[0] = coeffsLarge[n] = 1;
		for (tjs_int i = 1; i < n; i++) {
			coeffsLarge[i] = getCombinationCoeffOverX(n, i, nMax + 1, prevCoeffs[i]);
		}
	}

	return rv;
}
END

	print $out;
}


sub bezierCoord {
	my ($t) = @_;
	my ($x, $y) = (0, 0);
	my $s = 1.0-$t;
	local ($N, @PX, @PY);

	foreach my $i (0..$N) {
		my $c = combination($N, $i);
		my $pt = $t ** $i;
		my $ps = $s ** ($N - $i);
		my $k = $c * $pt * $ps;
		$x += $k * $PX[i];
		$y += $k * $PY[i];
	}

	return ($x, $y);
}





