
# ろくでもないスクリプト

use strict;

use utf8;
my $ENCODE_NAME = ':encoding(shift_jis)';
binmode(STDIN,  $ENCODE_NAME);
binmode(STDOUT, $ENCODE_NAME);

my $HeadSrc = << "END";
//----------------------------
// Generated by $0
//----------------------------

#ifndef _TVP_PLUGIN_LAYER_BUFFER_IMPL_H_
#define _TVP_PLUGIN_LAYER_BUFFER_IMPL_H_

#include <windows.h>
#include "tp_stub.h"
#include "KRLayerIntf.h"

/*
レイヤ情報を引数にもたないものは、描画クリップ領域が無視される。

*/

#define DRAW_CHECK \\
const tTVPRect * const draw = info->drawRect; \\
if (x < draw->left || y < draw->top || x > draw->right || y > draw->bottom) return;


END

###PV_FLAG###
###BP_TYPE###
###PX_TYPE###

my $GetPixelSrc = << 'END';
inline ###BP_TYPE### * LayerBuffer_getBufferPtr###PV_FLAG###(
	tjs_int x,
	tjs_int y,
	const tjs_uint8 * bufferptr,
	tjs_int bufferpitch)
{
	return (###BP_TYPE### *)(bufferptr + y * bufferpitch + x * sizeof(###BP_TYPE###));
}

inline ###BP_TYPE### * LayerBuffer_getBufferPtr###PV_FLAG###_Strict(
	tjs_int x,
	tjs_int y,
	tjs_int width,
	tjs_int height,
	const tjs_uint8 * bufferptr,
	tjs_int bufferpitch)
{
	###BP_TYPE### * p = NULL;
	if ((x >= 0) && (y >= 0) && (x < width) && (y < height)) {
		p = LayerBuffer_getBufferPtr###PV_FLAG###(x, y, bufferptr, bufferpitch);
	}
	return p;
}

inline ###BP_TYPE### * LayerBuffer_getBufferPtr###PV_FLAG###_StrictDraw(
	tjs_int x,
	tjs_int y,
	const LayerInfo * info)
{
	###BP_TYPE### * p = NULL;
	const tTVPRect * const draw = info->drawRect;
	if ((x >= draw->left) && (y >= draw->top) && (x <= draw->right) && (y <= draw->bottom)) {
	//if ((x >= 0) && (y >= 0) && (x < info->width) && (y < info->height)) {
		p = LayerBuffer_getBufferPtr###PV_FLAG###(x, y, info->bufferptr###PV_FLAG###, info->bufferpitch###PV_FLAG###);
	}
	return p;
}


inline ###PX_TYPE### LayerBuffer_getPixel###PV_FLAG###(
	tjs_int x,
	tjs_int y,
	const tjs_uint8 * bufferptr,
	tjs_int bufferpitch,
	tjs_int width,
	tjs_int height)
{
	tjs_uint rv = 0;
	if ((x >= 0) && (y >= 0) && (x < width) && (y < height)) {
		rv = *LayerBuffer_getBufferPtr###PV_FLAG###(x, y, bufferptr, bufferpitch);
	}
	return rv;
}


inline ###PX_TYPE### LayerBuffer_getPixel###PV_FLAG###(
	tjs_int x,
	tjs_int y,
	const LayerInfo * info)
{
	return LayerBuffer_getPixel###PV_FLAG###(x, y, info->bufferptr###PV_FLAG###, info->bufferpitch###PV_FLAG###, info->width, info->height);
}

inline ###PX_TYPE### LayerBuffer_getPixel###PV_FLAG###_NoCheck(
	tjs_int x,
	tjs_int y,
	const tjs_uint8 * bufferptr,
	tjs_int bufferpitch)
{
	return *LayerBuffer_getBufferPtr###PV_FLAG###(x, y, bufferptr, bufferpitch);
}

inline ###PX_TYPE### LayerBuffer_getPixel###PV_FLAG###_NoCheck(
	tjs_int x,
	tjs_int y,
	const LayerInfo * info)
{
	return LayerBuffer_getPixel###PV_FLAG###_NoCheck(x, y, info->bufferptr###PV_FLAG###, info->bufferpitch###PV_FLAG###);
}


END


my $FootSrc = << 'END';
#undef DRAW_CHECK
#endif _TVP_PLUGIN_LAYER_BUFFER_IMPL_H_
END


my @OpaSuffixes = ('', '_a', '_d', '_xo');
my @NoCheckSuffixes = ('_NoCheck', '');
my @ArgExts = (0, 1);




print $HeadSrc;
foreach my $pvf ('', 'Pv') {
	my $bptype = $pvf ? 'tjs_uint8' : 'tjs_uint32';
	my $pxtype = $pvf ? 'tjs_uint8' : 'tjs_uint';
	my $t = $GetPixelSrc;
	$t =~ s/###PX_TYPE###/$pxtype/g;
	$t =~ s/###BP_TYPE###/$bptype/g;
	$t =~ s/###PV_FLAG###/$pvf/g;
	print $t;
}

foreach my $ncx (@NoCheckSuffixes) {
foreach my $agx (@ArgExts) {
foreach my $opx (@OpaSuffixes) {
	print makeSrc($opx, $ncx, $agx);
}}}
print $FootSrc;



# inline void LayerBuffer_setPixel***(...) を作成する
# わけわかんね
sub makeSrc {
	my ($opx, $ncx, $agx) = @_;
	my $funcDecl = "inline void LayerBuffer_setPixel${opx}${ncx}";
	my $indent = ($ncx || $agx) ? "\t" : "\t\t";
	my $impl = '';
	my $xo = ($opx eq '_xo');
	my $argsWO   = 'x, y, col, opa, info->bufferptr, info->bufferpitch, info->width, info->height';
	my $argsWONC = 'x, y, col, opa, info->bufferptr, info->bufferpitch';
	my $argsNO   = 'x, y, col, info->bufferptr, info->bufferpitch, info->width, info->height';
	my $argsNONC = 'x, y, col, info->bufferptr, info->bufferpitch';
	my $argsNC = 'x, y, bufferptr, bufferpitch';
	my $ncxF = '_NoCheck';
	my $drawCK = "\tDRAW_CHECK;\n";

	if ($ncx) {
		$argsWO = $argsWONC;
		$argsNO = $argsNONC;
	}

	# レイヤ情報なしで自動判別は無理
	if (!$agx && $xo) {return '';}

	# 引数にLayerInfoがあるときは、常にdraw領域の確認をする。

	# 引数にLayerInfo で _xo
	if ($agx && $xo) {
		$impl = $drawCK;
		$impl .= << "END";
${indent}tjs_int face = info->face;
${indent}if (face == dfAlpha) {
${indent}	LayerBuffer_setPixel_d${ncx}(${argsWO});
${indent}} else if (face == dfAddAlpha) {
${indent}	LayerBuffer_setPixel_a${ncx}(${argsWO});
${indent}} else {
${indent}	//case dfOpaque: // main only
${indent}	//case dfMask: // mask ( opacity will be ignored )
${indent}	//case dfProvince: // province ( opacity will be ignored )
${indent}	//default:
${indent}}
END

	# 引数にLayerInfo で _d _a
	} elsif ($agx) {
		$impl = $drawCK;
		$impl .= $opx ? 
		"${indent}LayerBuffer_setPixel${opx}${ncx}(${argsWO});" :
		"${indent}LayerBuffer_setPixel${ncx}(${argsNO});";

	# 引数にLayerInfoがないときは、常にdraw領域は無視される。（確認できないため）

	# 引数ベタで不透明度あり
	} elsif ($opx) {
		$impl .=
		"${indent}tjs_uint32 * p = LayerBuffer_getBufferPtr(${argsNC});\n" .
		"${indent}TVPConstColorAlphaBlend${opx}(p, 1, col, opa);" ;

	# 引数ベタで不透明度なし
	} else {
		$impl =
		"${indent}tjs_uint32 * p = LayerBuffer_getBufferPtr(${argsNC});\n" .
		"${indent}*p = col;";
	}

	if (!$ncx && !$agx) {
		$impl = << "END";
	if ((x >= 0) && (y >= 0) && (x < width) && (y < height)) {
$impl
	}
END
	}
	my $argOpa = $opx ? "\ttjs_int opa,\n" : '';
	my $arg1 = << "END";
	tjs_int x,
	tjs_int y,
	tjs_uint col,
${argOpa}	const LayerInfo * info)
END
	my $arg2 = << "END";
	tjs_int x,
	tjs_int y,
	tjs_uint col,
${argOpa}	const tjs_uint8 * bufferptr,
END

	if ($ncx) {
		$arg2 .= << "END";
	tjs_int bufferpitch)
END
	} else {
		$arg2 .= << "END";
	tjs_int bufferpitch,
	tjs_int width,
	tjs_int height)
END
	}

	my $argDecl = $agx ? $arg1 : $arg2;

	# これが本体
	my $rv = << "END";
${funcDecl}(
${argDecl}{
${impl}
}

END

	return $rv;
}


