//---------------------------------------------------------------------------
#include "util_graph.h"
#include "GraphFunc.h"
#include "PaintFunc.h"
#include "GradationFunc.h"
#include "FilterFunc.h"
#include "JuliaFunc.h"
#include "Morph.h"

#include <lmcons.h>

//---------------------------------------------------------------------------

#define VALIDATE_OPA(a) if (a >  255) a =  255; if (a < -255) a = -255;

// XVtO
// ނ݂ɕύXȂƁI
bool TPFAutoUpdateMode = true;

#define TP_THROW_EXCEPTION_FACE TVPThrowExceptionMessage(TJS_W("ΉĂȂ`惂[hł"));



//---------------------------------------------------------------------------
// {Iɂ͉ȂĂǁc
//---------------------------------------------------------------------------
void TVPCallBeforeV2LinkExit(void)
{
	TVPPlugInCreateTable();
}

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawLineFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_INT(x1)
	TP_GET_REQ_PARAM_INT(y1)
	TP_GET_REQ_PARAM_INT(x2)
	TP_GET_REQ_PARAM_INT(y2)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_drawLineImpl(&info, x1, y1, x2, y2, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawFillTriangleFunction)
{
	TP_REQ_NUM_PARAMS(7)
	TP_GET_REQ_PARAM_INT(x1)
	TP_GET_REQ_PARAM_INT(y1)
	TP_GET_REQ_PARAM_INT(x2)
	TP_GET_REQ_PARAM_INT(y2)
	TP_GET_REQ_PARAM_INT(x3)
	TP_GET_REQ_PARAM_INT(y3)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_drawFillTriangleImpl(&info, x1, y1, x2, y2, x3, y3, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawCircleFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(r)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);
	rv = Layer_drawCircleImpl(&info, x, y, r, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawFillCircleFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(r)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_drawFillCircleImpl(&info, x, y, r, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawEllipseFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_INT(x)   // SW
	TP_GET_REQ_PARAM_INT(y)   // SW
	TP_GET_REQ_PARAM_INT(ra)  // Xa
	TP_GET_REQ_PARAM_INT(rb)  // Ya
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);
	rv = Layer_drawEllipseImpl(&info, x, y, ra, rb, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawFillEllipseFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_INT(x)   // SW
	TP_GET_REQ_PARAM_INT(y)   // SW
	TP_GET_REQ_PARAM_INT(ra)  // Xa
	TP_GET_REQ_PARAM_INT(rb)  // Ya
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);
	rv = Layer_drawFillEllipseImpl(&info, x, y, ra, rb, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawRoundRectFunction)
{
	TP_REQ_NUM_PARAMS(6)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	TP_GET_REQ_PARAM_INT(r)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_drawRoundRectImpl(&info, x, y, w, h, r, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawFillRoundRectFunction)
{
	TP_REQ_NUM_PARAMS(6)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	TP_GET_REQ_PARAM_INT(r)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_drawFillRoundRectImpl(&info, x, y, w, h, r, col, opa);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawGradatedColorRectFunction)
{
	TP_REQ_NUM_PARAMS(7)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	TP_GET_REQ_PARAM_INT(type)
	TP_GET_REQ_PARAM_REAL(dir)	// in radian
	TP_GET_REQ_PARAM_OBJ(colarray)	// Array

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	// Fz
	tjs_int numCols = Array_PropGet_count(colarray);
	// 2ȏKv
	if (numCols < 2) {
		TVPThrowExceptionMessage(TJS_W("Fz̗vf܂iwF%1 KvF2j"), (ttstr)numCols);
	}

	// Fzitjs_uint32j
	tjs_uint32 * cols = new tjs_uint32[numCols];

	try {
		for (tjs_int i = 0; i < numCols; i++) {
			cols[i] = Array_PropGetByNumAsUInt(colarray, i);
		}
		rv = Layer_drawGradatedColorRectImpl(&info, x, y, w, h, type, dir, cols, numCols, opa);
		delete[] cols;
	} catch (...) {
		delete[] cols;
		throw;
	}

	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawGradatedColorCircleFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(r)
	TP_GET_REQ_PARAM_OBJ(colarray)	// Array

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	// Fz
	tjs_int numCols = Array_PropGet_count(colarray);
	// 2ȏKv
	if (numCols < 2) {
		TVPThrowExceptionMessage(TJS_W("Fz̗vf܂iwF%1 KvF2j"), (ttstr)numCols);
	}

	// Fzitjs_uint32j
	tjs_uint32 * cols = new tjs_uint32[numCols];
	try {
		for (tjs_int i = 0; i < numCols; i++) {
			cols[i] = Array_PropGetByNumAsUInt(colarray, i);
		}

		rv = Layer_drawGradatedColorCircleImpl(&info, x, y, r, cols, numCols, opa);
		delete[] cols;
	} catch (...) {
		delete[] cols;
		throw;
	}

	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawGradatedColorEllipseFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(ra)
	TP_GET_REQ_PARAM_INT(rb)
	TP_GET_REQ_PARAM_OBJ(colarray)	// Array

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)

	tjs_int rv = 0;
	LayerInfo info;
	info.setForWrite(objthis);

	// Fz
	tjs_int numCols = Array_PropGet_count(colarray);
	// 2ȏKv
	if (numCols < 2) {
		TVPThrowExceptionMessage(TJS_W("Fz̗vf܂iwF%1 KvF2j"), (ttstr)numCols);
	}

	// Fzitjs_uint32j
	tjs_uint32 * cols = new tjs_uint32[numCols];
	try {
		for (tjs_int i = 0; i < numCols; i++) {
			cols[i] = Array_PropGetByNumAsUInt(colarray, i);
		}

		rv = Layer_drawGradatedColorEllipseImpl(&info, x, y, ra, rb, cols, numCols, opa);
		delete[] cols;
	} catch (...) {
		delete[] cols;
		throw;
	}

	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tAutoUpdateModeFunction)
{
	TP_REQ_NUM_PARAMS(0)
	tjs_int oldmode = TPFAutoUpdateMode;
	TP_GET_OPT_PARAM_TC(TPFAutoUpdateMode, tTVInteger)
	TP_SET_RETURN_VALUE_INT(oldmode)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tPaintFunction)
{
	TP_REQ_NUM_PARAMS(3)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_UINT(col)

	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)
	// QƖʎw
	TP_GET_OPT_PARAM_INT(ref, TP_PAINT_REF_OPAQUE)

	tjs_int rv = 0;
	LayerInfo info;
	LayerInfo pvinfo;
	info.setForWrite(objthis);
	pvinfo.setForReadPv(objthis);

	rv = Layer_paintImpl(&info, &pvinfo, x, y, col, opa, ref);
	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tGrayFilterFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	TP_GET_REQ_PARAM_INT(type)

	// optional
	TP_GET_OPT_PARAM_INT(size, 3)
	TP_GET_OPT_PARAM_INT(lc, TP_LUMINANCE_COEFFICIENTS_Y709)
	TP_GET_OPT_PARAM_OBJ(kernel, NULL)

	bool rv = false;
	LayerInfo info;
	info.setForWrite(objthis);

/*
	if (size < 3) size = 3;
	if (size % 2) --size;
*/
	size = 3;

	// [UwJ[l
	tjs_int sizesq = size * size;
	tjs_int * kern = new tjs_int[sizesq];

	try {
		if (kernel != NULL) {
			tjs_int count = Array_PropGet_count(kernel);
			for (tjs_int i = 0; i < count; i++) {
				kern[i] = Array_PropGetByNumAsInt(kernel, i);
			}
			for (tjs_int i = count; i < sizesq; i++) {
				kern[i] = 0;
			}
		} else {
			for (tjs_int i = 0; i < sizesq; i++) {
				kern[i] = 0;
			}
		}

		if (size == 3) {
			rv = Layer_grayFilter3x3Impl(&info, x, y, w, h, type, lc, kern);
		}

	} catch (...) {
		delete[] kern;
		throw;
	}

	delete[] kern;

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tColorFilterFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	TP_GET_REQ_PARAM_INT(type)

	// optional
	TP_GET_OPT_PARAM_INT(size, 3)
	TP_GET_OPT_PARAM_OBJ(kernel, NULL)

	bool rv = false;
	LayerInfo info;
	info.setForWrite(objthis);

	if (size < 3) size = 3;

	// [UwJ[l
	tjs_int sizesq = size * size;
	tjs_int * kern = new tjs_int[sizesq];

	try {
		if (kernel != NULL) {
			tjs_int count = Array_PropGet_count(kernel);
			for (tjs_int i = 0; i < count; i++) {
				kern[i] = Array_PropGetByNumAsInt(kernel, i);
			}
			for (tjs_int i = count; i < sizesq; i++) {
				kern[i] = 0;
			}
		} else {
			for (tjs_int i = 0; i < sizesq; i++) {
				kern[i] = 0;
			}
		}

		rv = Layer_colorFilterImpl(&info, x, y, w, h, type, size, kern);
	} catch (...) {
		delete[] kern;
		throw;
	}

	delete[] kern;

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tEqualizeFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	// optional
	TP_GET_OPT_PARAM_INT(lc, TP_LUMINANCE_COEFFICIENTS_Y709)

	bool rv = false;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_equalizeImpl(&info, x, y, w, h, lc, false);

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tEqualizeColorFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_INT(x)
	TP_GET_REQ_PARAM_INT(y)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	// optional
	TP_GET_OPT_PARAM_INT(lc, TP_LUMINANCE_COEFFICIENTS_Y709)

	bool rv = false;
	LayerInfo info;
	info.setForWrite(objthis);

	rv = Layer_equalizeImpl(&info, x, y, w, h, lc, true);

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// WA`
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawJuliaSetFunction)
{
	TP_REQ_NUM_PARAMS(11)

	// J[R[hZo֐
	TP_GET_REQ_PARAM_CLO(func)
	// fẄ
	TP_GET_REQ_PARAM_REAL(re_begin)
	TP_GET_REQ_PARAM_REAL(im_begin)
	TP_GET_REQ_PARAM_REAL(re_width)
	TP_GET_REQ_PARAM_REAL(im_width)
	// C݈ʒu
	TP_GET_REQ_PARAM_INT(left)
	TP_GET_REQ_PARAM_INT(top)
	// zTCYiC݃TCYj
	TP_GET_REQ_PARAM_INT(array_width)
	TP_GET_REQ_PARAM_INT(array_height)
	// f萔
	TP_GET_REQ_PARAM_REAL(re)
	TP_GET_REQ_PARAM_REAL(im)
	// N
	TP_GET_OPT_PARAM_INT(pow, 2)
	// [vE
	TP_GET_OPT_PARAM_INT(iteration_limit, 255)

	tjs_int rv = 0;

	if ((array_width > 0) && (array_height > 0)) {
		tjs_int array_size = array_width * array_height;
		tjs_int * juliaset = new tjs_int[array_size]; // Zoʊi[z
		rv = CalcJuliaSet(FT_JULIA, re_begin, im_begin, re_width, im_width, 
			juliaset, array_width, array_height, 
			re, im, pow, iteration_limit);

		// `Ɉڂ
		if (rv) {
			rv = DrawFractalImpl(objthis, func, juliaset, left, top, array_width, array_height);
		}

		delete[] juliaset; // Y
	}

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// }fu`
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawMandelbrotSetFunction)
{
	TP_REQ_NUM_PARAMS(9)

	// J[R[hZo֐
	TP_GET_REQ_PARAM_CLO(func)
	// fẄ
	TP_GET_REQ_PARAM_REAL(re_begin)
	TP_GET_REQ_PARAM_REAL(im_begin)
	TP_GET_REQ_PARAM_REAL(re_width)
	TP_GET_REQ_PARAM_REAL(im_width)
	// C݈ʒu
	TP_GET_REQ_PARAM_INT(left)
	TP_GET_REQ_PARAM_INT(top)
	// zTCYiC݃TCYj
	TP_GET_REQ_PARAM_INT(array_width)
	TP_GET_REQ_PARAM_INT(array_height)
	// N
	TP_GET_OPT_PARAM_INT(pow, 2)
	// [vE
	TP_GET_OPT_PARAM_INT(iteration_limit, 255)

	tjs_int rv = 0;

	if ((array_width > 0) && (array_height > 0)) {
		tjs_int array_size = array_width * array_height;
		tjs_int * juliaset = new tjs_int[array_size]; // Zoʊi[z
		rv = CalcJuliaSet(FT_MANDELBROT, re_begin, im_begin, re_width, im_width, 
			juliaset, array_width, array_height, 
			0, 0, pow, iteration_limit);

		// `Ɉڂ
		if (rv) {
			rv = DrawFractalImpl(objthis, func, juliaset, left, top, array_width, array_height);
		}

		delete[] juliaset; // Y
	}

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// pgbNȐ
//---------------------------------------------------------------------------
//Ȑ̏ꍇ́AI_WǉĂɓnB

#define PARAMETRIC_CURVE_TYPE_IS_CLOSE (type == PCURVE_TYPE_CUBIC_SPLINE_CLOSE) || (type == PCURVE_TYPE_CHAIKIN_CLOSE)

#define PARAMETRIC_CURVE_PREPROCESS(_array) \
	ParametricCurveTracer * curve; \
	tjs_int count = Array_PropGet_count(_array); \
	tjs_int arraysize; \
	if (accuracy < 1) accuracy = 1; \
 \
	/*  */ \
	if (type >= 0) { \
		arraysize = count / 2; \
		/* Ȑ̏ꍇ̓ */ \
		if (PARAMETRIC_CURVE_TYPE_IS_CLOSE) arraysize++; \
		if (type == PCURVE_TYPE_STUB) accuracy = 1; \
		curve = GetParametricCurveTracer(type); \
	/* [U` */ \
	} else { \
		if (callbackX == NULL || callbackY == NULL) { \
			TVPThrowExceptionMessage(TJS_W("R[obN֐w肵Ă")); \
		} \
		arraysize = accuracy; \
		curve = GetParametricCurveTracer(PCURVE_TYPE_STUB); \
	} \
	if (curve == NULL) TVPThrowExceptionMessage(TJS_W("pgbNȐ̌^ł")); \
	/* p[^`FbN */ \
	{ \
		tjs_int nReqPoints = curve->getRequiredPoints(); \
		tjs_int nLimPoints = curve->getLimitPoints(); \
		if (arraysize < nReqPoints) { \
			FreeParametricCurveTracer(curve); \
			TVPThrowExceptionMessage(TJS_W("_܂iwF%1 KvF%2j"), (ttstr)arraysize, (ttstr)nReqPoints); \
		} \
		if (nLimPoints >= 0 && arraysize > nLimPoints) { \
			FreeParametricCurveTracer(curve); \
			TVPThrowExceptionMessage(TJS_W("_܂iwF%1 ő吔F%2j"), (ttstr)arraysize, (ttstr)nLimPoints); \
		} \
	}


// [UwȐłȂꍇɌĂ΂
static void processParametricCurve(
	ParametricCurveTracer * curve, iTJSDispatch2 * array, 
	tjs_int type, tjs_int * xp, tjs_int * yp, tjs_int arraysize)
{
	/* C^[[uԂX,Yɕ */
	try {
		(PARAMETRIC_CURVE_TYPE_IS_CLOSE) ?
			Array_uninterleaveXY(array, arraysize-1, xp, yp):
			Array_uninterleaveXY(array, arraysize  , xp, yp);
	} catch (...) {
		FreeParametricCurveTracer(curve);
		delete[] xp;
		delete[] yp;
		throw;
	}

	/* Ȑ̏ꍇ̓ */
	if (PARAMETRIC_CURVE_TYPE_IS_CLOSE) {
		xp[arraysize-1] = xp[0];
		yp[arraysize-1] = yp[0];
	}

	return;
}

// [U`֐̏ꍇɌĂ΂
static void createStubCurvePath(
	tTJSVariantClosure * callbackX, 
	tTJSVariantClosure * callbackY, 
	iTJSDispatch2 * param_array,
	tjs_int * xp, tjs_int * yp, tjs_int arraysize)
{
	static tjs_uint32 xhint = 0;
	static tjs_uint32 yhint = 0;

	const tjs_int num_params = 2;
	tTJSVariant result;
	tTJSVariant ** params = new tTJSVariant*[num_params];
	params[0] = new tTJSVariant();
	params[1] = new tTJSVariant(param_array, param_array);

	for (tjs_int i = 0; i < arraysize; i++) {
		tjs_real t = (tjs_real)i / (tjs_real)(arraysize - 1);
		*(params[0]) = t;

		try {
			callbackX->FuncCall(0, NULL, &xhint, &result, num_params, params, NULL);
			xp[i] = (tTVInteger)result;
			callbackX->FuncCall(0, NULL, &yhint, &result, num_params, params, NULL);
			yp[i] = (tTVInteger)result;
		} catch (...) {
			delete params[0];
			delete params[1];
			delete[] params;
			throw;
		}
	}

	delete params[0];
	delete params[1];
	delete[] params;

	return;
}


/*
[UwR[obN֐F
callback = function (t, param_array) // 0.0 <= t <= 1.0
{
	var x = calculate(t, param_array);
	return x;
} incontextof hoge;
*/

//---------------------------------------------------------------------------
// `
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tDrawParametricCurveFunction)
{
	TP_REQ_NUM_PARAMS(4)
	TP_GET_REQ_PARAM_OBJ(path)
	TP_GET_REQ_PARAM_INT(accuracy)
	TP_GET_REQ_PARAM_INT(type)
	TP_GET_REQ_PARAM_INT(col)
	// sxw
	TP_GET_OPT_PARAM_INT(opa, 255)
	VALIDATE_OPA(opa)
	// [UwR[obN֐
	TP_GET_OPT_PARAM_CLO(callbackX, NULL)
	TP_GET_OPT_PARAM_CLO(callbackY, NULL)

	tjs_int rv = 0;

	PARAMETRIC_CURVE_PREPROCESS(path)

	tjs_int * xpath = new tjs_int[arraysize];
	tjs_int * ypath = new tjs_int[arraysize];

	try {
		(type >= 0) ?
			processParametricCurve(curve, path, type, xpath, ypath, arraysize) :
			createStubCurvePath(callbackX, callbackY, path, xpath, ypath, arraysize);

		curve->init(xpath, ypath, arraysize, accuracy);

		LayerInfo info;
		info.setForWrite(objthis);

		rv = Layer_drawParametricCurveImpl(&info, curve, col, opa);

		FreeParametricCurveTracer(curve);
	} catch (...) {
		delete[] xpath;
		delete[] ypath;
		throw;
	}

	delete[] xpath;
	delete[] ypath;

	if (rv < 0) TP_THROW_EXCEPTION_FACE

	TP_SET_RETURN_VALUE_INT(rv)
	return TJS_S_OK;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// W擾
//---------------------------------------------------------------------------
TVP_PLUGIN_FUNCCALL_DECL(tGetParametricCurveCoordsFunction)
{
	TP_REQ_NUM_PARAMS(2)
	TP_GET_REQ_PARAM_INT(accuracy)
	TP_GET_REQ_PARAM_INT(type)
	// [UwR[obN֐
	TP_GET_OPT_PARAM_CLO(callbackX, NULL)
	TP_GET_OPT_PARAM_CLO(callbackY, NULL)

	iTJSDispatch2 * coords = TJSCreateArrayObject();

	PARAMETRIC_CURVE_PREPROCESS(objthis)

	tjs_int * xpath = new tjs_int[arraysize];
	tjs_int * ypath = new tjs_int[arraysize];

	try {
		(type >= 0) ?
			processParametricCurve(curve, objthis, type, xpath, ypath, arraysize) :
			createStubCurvePath(callbackX, callbackY, objthis, xpath, ypath, arraysize);

		curve->init(xpath, ypath, arraysize, accuracy);

		if (curve->isActive()) {
			tjs_int cx = 0, cy = 0;
			tTJSVariant val; // work
			tjs_int numPoints = curve->getNumPoints();
			tjs_int accuracy  = curve->getAccuracy();

			for (tjs_int index = 0; index < numPoints - 1; index++) {
				for (tjs_int subindex = 0; subindex < accuracy; subindex++) {
					curve->getCoord(index, subindex, cx, cy);
					val = cx;
					Array_FuncCall_add(coords, &val);
					val = cy;
					Array_FuncCall_add(coords, &val);
				}
			}

			// Ō̈_
			curve->getCoord(numPoints - 2, accuracy, cx, cy);
			val = cx;
			Array_FuncCall_add(coords, &val);
			val = cy;
			Array_FuncCall_add(coords, &val);
		}

		FreeParametricCurveTracer(curve);
	} catch (...) {
		delete[] xpath;
		delete[] ypath;
		throw;
	}

	delete[] xpath;
	delete[] ypath;

	TP_SET_RETURN_VALUE_OBJ(coords)
	coords->Release();

	return TJS_S_OK;
}
//---------------------------------------------------------------------------

#undef PARAMETRIC_CURVE_TYPE_IS_CLOSE


/*
dest(objthis): ݐ
src1: [tBOC
points1: [tBOC̒_WQ
src2: [tBO惌C
points2: [tBOC̒_WQƈΈőΉA[tBO惌C̍WQ
ratio: [tBOis(Real 0.0-1.0)
*/

TVP_PLUGIN_FUNCCALL_DECL(tLayerMorphFunction)
{
	TP_REQ_NUM_PARAMS(5)
	TP_GET_REQ_PARAM_OBJ(src1var)	// iTJSDispatch2 (Layer)
	TP_GET_REQ_PARAM_OBJ(points1var)	// iTJSDispatch2 (Array of Real)
	TP_GET_REQ_PARAM_OBJ(src2var)	// iTJSDispatch2 (Layer)
	TP_GET_REQ_PARAM_OBJ(points2var)	// iTJSDispatch2 (Array of Real)
	TP_GET_REQ_PARAM_REAL(morphRatio)	// tjs_real

	tjs_int rv = 0;

	// is`FbN
	if (morphRatio < 0.0 || morphRatio > 1.0) {
		TVPThrowExceptionMessage(TJS_W("is͈͊Oł"));
	}

	// C
	LayerInfo src1Info;
	LayerInfo src2Info;
	LayerInfo destInfo;
	src1Info.setForRead(src1var);
	src2Info.setForRead(src2var);
	destInfo.setForWrite(objthis);

	// C`FbN
	// C[WTCY͑SēH
	if ((destInfo.width != src1Info.width) ||
		(destInfo.width != src2Info.width) ||
		(destInfo.height != src1Info.height) ||
		(destInfo.height != src2Info.height)) {
//		TVPThrowExceptionMessage(TJS_W("C̃C[WTCY͑SēłȂ΂Ȃ܂idest:%1 src1:%2j"), (ttstr)destInfo.height, (ttstr)src2Info.width); \
		TVPThrowExceptionMessage(TJS_W("C̃C[WTCY͑SēłȂ΂Ȃ܂"));
	}

	// _
	tjs_int nPoints = 0;	// l̕
	tjs_int nPoints0 = 0;	// l̕Ȃ
	{
		tjs_int count1 = Array_PropGet_count(points1var);
		tjs_int count2 = Array_PropGet_count(points2var);
		// Ȃɂ
		nPoints0 = (count1 < count2) ? count1 : count2;
		nPoints0 /= 2;
		nPoints = nPoints0 + 4;	// l̕
	}

#define F__FREE_MORPH_POINTS \
	delete[] points1x; \
	delete[] points1y; \
	delete[] points2x; \
	delete[] points2y;

	// _izj
	tjs_real * points1x = new tjs_real[nPoints];
	tjs_real * points1y = new tjs_real[nPoints];
	tjs_real * points2x = new tjs_real[nPoints];
	tjs_real * points2y = new tjs_real[nPoints];

/*
	array points#* :
	+----+----+----+----+----+----+--
	|  0 |  1 |  2 |  3 |  4 |  5 | c
	+----+----+----+----+----+----+--
	  E E  usr0 usr1 c
*/

	// C^[[u
	try {
		// CfbNX 0`3 ͎l̕Ȃ̂ŋ󂯂Ă
		Array_uninterleaveXY(points1var, nPoints0, points1x + 4, points1y + 4);
		Array_uninterleaveXY(points2var, nPoints0, points2x + 4, points2y + 4);
	} catch (...) {
		F__FREE_MORPH_POINTS
		throw;
	}

	// l̕ǉ
	// dest, src1, src2̃C[WTCYȂ̂O
	//   1 2
	//   4 3
	{
		// 󂯂ĂCfbNX 0`3 l̍WŖ߂
		tjs_int p = 0;
		points1x[p] = points2x[p] = 0;
		points1y[p] = points2y[p] = 0;
		p++;
		points1x[p] = points2x[p] = destInfo.width  - 1;
		points1y[p] = points2y[p] = 0;
		p++;
		points1x[p] = points2x[p] = destInfo.width  - 1;
		points1y[p] = points2y[p] = destInfo.height - 1;
		p++;
		points1x[p] = points2x[p] = 0;
		points1y[p] = points2y[p] = destInfo.height - 1;
	}

	// Morph!
	try {
		rv = morphImpl(&destInfo, &src1Info, &src2Info, 
			points1x, points1y, points2x, points2y, 
			nPoints, morphRatio);
	} catch (...) {
		F__FREE_MORPH_POINTS
		throw;
	}

	// N͗pς݂
	F__FREE_MORPH_POINTS
#undef F__FREE_MORPH_POINTS

	TP_SET_RETURN_VALUE_INT(rv)

	return TJS_S_OK;

}



/*
dest(return): ݐ
objthis: coords
w, h
*/

TVP_PLUGIN_FUNCCALL_DECL(tArrayTriangulateFunction)
{
	TP_REQ_NUM_PARAMS(2)
	TP_GET_REQ_PARAM_INT(w)
	TP_GET_REQ_PARAM_INT(h)
	TP_GET_OPT_PARAM_INT(mode, TRIANGULATE_MODE_DELAUNEY)	// gp

	// _
	tjs_int nPoints0 = Array_PropGet_count(objthis) / 2;	// l̕Ȃ
	tjs_int nPoints = nPoints0 + 4;	// l̕

#define F__FREE_MORPH_POINTS \
	delete[] points1x; \
	delete[] points1y;

	// _izj
	tjs_real * points1x = new tjs_real[nPoints];
	tjs_real * points1y = new tjs_real[nPoints];

	// C^[[u
	try {
		// CfbNX 0`3 ͎l̕Ȃ̂ŋ󂯂Ă
		Array_uninterleaveXY(objthis, nPoints0, points1x + 4, points1y + 4);
	} catch (...) {
		F__FREE_MORPH_POINTS
		throw;
	}

	// l̕ǉ
	{
		// 󂯂ĂCfbNX 0`3 l̍WŖ߂
		points1x[0] = 0;
		points1y[0] = 0;
		points1x[1] = w - 1;
		points1y[1] = 0;
		points1x[2] = w - 1;
		points1y[2] = h - 1;
		points1x[3] = 0;
		points1y[3] = h - 1;
	}

	// triangulate
	TPDelaunay dt;
	dt.InitQuad(
		points1x[0], points1y[0], 
		points1x[1], points1y[1], 
		points1x[2], points1y[2], 
		points1x[3], points1y[3]);

	for (tjs_int i = 4; i < nPoints; i++) {
		dt.AddPtPos(points1x[i], points1y[i]);
	}

	// 
	iTJSDispatch2 * tmpArray = TJSCreateArrayObject();

	// Op`
	tjs_int nTriangle = dt.CountTri();
	for (tjs_int i = 0; i < nTriangle; i++) {
		double x1[3], y1[3];
		dt.GetPtPosOfTri(i, x1[0], y1[0], x1[1], y1[1], x1[2], y1[2]);

		// Op`_
		TrianglePos tri(x1[0], y1[0], x1[1], y1[1], x1[2], y1[2]);
		// ͂ݏo`FbN
		if (!tri.isContentOf(w, h)) {
			TVPThrowExceptionMessage(TJS_W("`͂ݏoĂ܂"));
		}

		tTJSVariant val;
		iTJSDispatch2 * eachArray = TJSCreateArrayObject();

		// Op`̒_W
		for (tjs_int j = 0; j < 3; j++) {
			val = x1[j];
			Array_FuncCall_add(eachArray, &val);
			val = y1[j];
			Array_FuncCall_add(eachArray, &val);
		}

		// אڂOp`̃CfbNX
		for (tjs_int edge = 0; edge < 3; edge++) {
			tjs_int adj = dt.GetAdjacent(i, edge);
			val = adj;
			Array_FuncCall_add(eachArray, &val);
		}

		val = *(new tTJSVariant(eachArray, eachArray));
		Array_FuncCall_add(tmpArray, &val);
		eachArray->Release();
	}

	// N͗pς݂
	F__FREE_MORPH_POINTS
#undef F__FREE_MORPH_POINTS

	TP_SET_RETURN_VALUE_OBJ(tmpArray)
	tmpArray->Release();

	return TJS_S_OK;

}



