#ifndef _TVP_PLUGIN_SQLITE3_INTF_H_
#define _TVP_PLUGIN_SQLITE3_INTF_H_

// http://wiki.manoeuvre.net:8080/index.php?%A5%E1%A5%E2#content_1_3
#define _UNICODE

#include "NIHolder.h"
#include "SqlitePlus.h"

// f[^^
#define TP_SQ3_DATATYPE_NULL    1
#define TP_SQ3_DATATYPE_AUTO    2
#define TP_SQ3_DATATYPE_INTEGER 3
#define TP_SQ3_DATATYPE_REAL    4
#define TP_SQ3_DATATYPE_STRING  5
#define TP_SQ3_DATATYPE_BLOB    6
#define TP_SQ3_DATATYPE_VOID    999999


class SQLite3ConnectionIntf;
class SQLite3StatementIntf;
class SQLite3CursorIntf;



BEGIN_CLASSDEF_INHERIT(SQLite3IntfBase, TPPseudoNativeClass)
public:
	tjs_int instanceID;
	std::vector<tjs_int> childID;

	thisclass() : inherited()
	{
		instanceID = -1;
	}

	virtual ~SQLite3IntfBase()
	{
		this->releaseInternalObjects();
	}

END_CLASSDEF



BEGIN_CLASSDEF_INHERIT(SQLite3ConnectionIntf, SQLite3IntfBase)
protected:
	sqlite3plus::SqliteConnection * db;

public:
	thisclass() : inherited()
	{
		db = NULL;
	}

	virtual ~SQLite3ConnectionIntf()
	{
		if (db != NULL) {
			db->close();
			delete db;
		}
	}

	// open DB
	virtual void open(tTJSString & file);

	// close DB
	virtual void close();

	// execute query (direct)
	virtual void executeQuery(tTJSString & query);

	// check query
	virtual bool isCompleteSQL(tTJSString & query);

	// column names
	virtual tjs_int columnNames(tTJSString & table, iTJSDispatch2 * array);

/*
	virtual SQLite3StatementIntf * createStatement(tTJSString & query);
*/

	// get version (static)
	static void version(tTJSString & rv);

	// get connection ref.
	sqlite3plus::SqliteConnection * getConnection();


END_CLASSDEF


// O new Ȃ
BEGIN_CLASSDEF_INHERIT(SQLite3StatementIntf, SQLite3IntfBase)
protected:
	sqlite3plus::SqliteStatementPtr statement;
	SQLite3ConnectionIntf * conn;

public:
	thisclass() : inherited()
	{
		conn = NULL;
	}

	virtual ~SQLite3StatementIntf()
	{
	}

	virtual void set(SQLite3ConnectionIntf * c, tTJSString & query);

	virtual void execute();

	virtual void reset();

	virtual sqlite3plus::SqliteStatementPtr getStatement();

END_CLASSDEF




// O new Ȃ
BEGIN_CLASSDEF_INHERIT(SQLite3CursorIntf, SQLite3IntfBase)
protected:
	sqlite3plus::SqliteCursorPtr cursor;
	SQLite3StatementIntf * statement;

public:
	thisclass() : inherited()
	{
		statement = NULL;
	}

	virtual ~SQLite3CursorIntf()
	{
	}

	virtual void set(SQLite3StatementIntf * s);

	virtual bool next();

	virtual bool isEOR();

	virtual void reset();

	virtual tjs_int columnType(tjs_int index);

	virtual sqlite3plus::SqliteCursorPtr getCursor();

	virtual tjs_int columnNum();

	virtual void columnName(tjs_int index, tTJSString & rv);

END_CLASSDEF


#endif  _TVP_PLUGIN_SQLITE3_INTF_H_
