/**************************************************************
*
*  Jul. 8, 2004
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SqliteException_H
#define SqliteException_H

#include <sqlite3.h>
#include <exception>
#include <string>

namespace sqlite3plus {

/// SQLite PlusŗpÕx[XNX

/// @note SqliteException𒼐throŵł͂ȂA
/// prɉĔhNXthrowׂłB
class SqliteException :
	public std::exception
{
protected:
	/// O̔R\iANSIj
	std::string		m_reason;

public:
	/// W̃RXgN^
	SqliteException(void)
		: std::exception()
	{}

	/// Rw肵č\z
	/**
	 * @param reason O̔RiANSIj
	 */
	SqliteException(const char* reason)
		: std::exception()
		, m_reason(reason)
	{}

	virtual ~SqliteException(void)
	{}

	/// O̔RZbgB
	/**
	 * @param reason O̔RiANSIj
	 */
	void setReason(const char* reason)
	{
		m_reason = reason;
	}

	/// O̔R擾B
	/**
	 * @return O̔RiANSIj
	 */
	const char* reason()
	{
		return m_reason.c_str();
	}

	/// O̖O擾B
	/**
	 * @return O̖OiANSIj
	 */
	virtual const char* what() const throw()
	{
		return "SqliteException";
	}
};

///LȔ͈͂ËɃANZX悤Ƃꍇthrow
class OutOfBoundsException : public SqliteException
{
public:
	OutOfBoundsException()
		: SqliteException()
	{}

	OutOfBoundsException(const char* reason)
		: SqliteException(reason)
	{}

	virtual const char* what() const throw()
	{
		return "OutOfBoundsException";
	}
};

///RlNVɊւG[̔throw
class ConnectionException : public SqliteException
{
public:
	ConnectionException()
		: SqliteException()
	{}

	ConnectionException(const char* reason)
		: SqliteException(reason)
	{}

	virtual const char* what() const throw()
	{
		return "ConnectionException";
	}
};

///SQL̎sɊւG[throw
class QueryException : public SqliteException
{
protected:
	/// SQLitẽG[R[h
	int		m_errorCode;

public:
	QueryException()
		: SqliteException()
		, m_errorCode(SQLITE_ERROR)
	{}

	QueryException(const char* reason, int errCode)
		: SqliteException(reason)
		, m_errorCode(errCode)
	{}

	/// O̎ʂ\ASQLitẽG[R[h擾B
	/**
	 * @note SQLitẽG[R[h́Asqlite3.hɋLڂĂB<br>
	 * iSQLITE_OK  SQLITE_DONE ܂ł̒萔j
	 * @return G[R[h
	 */
	int errorCode()
	{
		return m_errorCode;
	}

	/// SQLitẽG[R[hZbg
	/**
	 * @param errorCode G[R[h
	 */
	void setErrorCode(int errorCode)
	{
		m_errorCode = errorCode;
	}

	virtual const char* what() const throw()
	{
		return "QueryException";
	}
};

};

#endif SqliteException_H

