/**************************************************************
*
*  Jul. 8, 2004
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SqliteFunction_H
#define SqliteFunction_H

#include "sqlite3.h"
#include "SqliteString.h"
#include "SqliteException.h"

namespace sqlite3plus {

/// [U`֐/AOQ[g̃x[XƂȂNX
class SqliteFunctionBase
{
public:
	/// ֐o^f[^x[Xnh
	sqlite3*			m_db;
	/// ֐̌ĂяoReLXgێiSQLite֐Ăяoۂɓnj
	sqlite3_context*	m_ctx;
	/// ֐
	SqliteString		m_name;
	/// ֐̎̐
	int					m_nArgs;
	/// ֐o^ɓn[Uf[^
	void*				m_userData;

protected:
	/// ی삳ꂽRXgN^B̃NX𒼐ڃCX^X邱Ƃ͖B
	/**
	 * @db SQLitef[^x[Xnh
	 */
	SqliteFunctionBase(sqlite3* db)
		: m_db(db)
		, m_ctx(NULL)
		, m_userData(NULL)
		, m_nArgs(0)
	{}

public:
	virtual ~SqliteFunctionBase()
	{}

	/// ֐ɓnꂽ̃^CvANULLł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvNULLłtrueAłȂfalse
	 */
	bool isNull(sqlite3_value* param)
	{
		return (sqlite3_value_type(param) == SQLITE_NULL);
	}

	/// ֐ɓnꂽ̃^CvAł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvłtrueAłȂfalse
	 */
	bool isStr(sqlite3_value* param)
	{
		return (sqlite3_value_type(param) == SQLITE_TEXT);
	}

	/// ֐ɓnꂽ̃^CvAł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvłtrueAłȂfalse
	 */
	bool isInt(sqlite3_value* param)
	{
		return (sqlite3_value_type(param) == SQLITE_INTEGER);
	}

	/// ֐ɓnꂽ̃^CvAł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvłtrueAłȂfalse
	 */
	bool isReal(sqlite3_value* param)
	{
		return (sqlite3_value_type(param) == SQLITE_FLOAT);
	}

	/// ֐ɓnꂽ̃^CvABLOBł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvBLOBłtrueAłȂfalse
	 */
	bool isBlob(sqlite3_value* param)
	{
		return (sqlite3_value_type(param) == SQLITE_BLOB);
	}

	/// ֐ɓnꂽ̒lAƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	SqliteString valueAsStr(sqlite3_value* param)
	{
		return SqliteString::fromUTF16(
			(const wchar_t*)sqlite3_value_text16(param));
	}

	/// ֐ɓnꂽ̒lAƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	int valueAsInt(sqlite3_value* param)
	{
		return sqlite3_value_int(param);
	}

	/// ֐ɓnꂽ̒lA64bitƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	__int64 valueAsInt64(sqlite3_value* param)
	{
		return sqlite3_value_int64(param);
	}

	/// ֐ɓnꂽ̒lAƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	double valueAsReal(sqlite3_value* param)
	{
		return sqlite3_value_double(param);
	}

	/// ֐ɓnꂽ̒lABLOBƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	const void* valueAsBlob(sqlite3_value* param)
	{
		return sqlite3_value_blob(param);
	}

	/// ֐ɓnꂽ̃oCg擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return oCg
	 * @note ̏ꍇAUTF8ƂẴoCgԂ
	 */
	int valueBytes(sqlite3_value* param)
	{
		return sqlite3_value_bytes(param);
	}

	/// ֐ɓnꂽ̃oCg擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 * @note ̏ꍇAUTF16ƂẴoCgԂ
	 */
	int valueBytes16(sqlite3_value* param)
	{
		return sqlite3_value_bytes16(param);
	}

	/// ֐̖߂liljZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(int val)
	{
		sqlite3_result_int(m_ctx, val);
	}

	/// ֐̖߂li64bitljZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(__int64 val)
	{
		sqlite3_result_int64(m_ctx, val);
	}

	/// ֐̖߂liljZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(double val)
	{
		sqlite3_result_double(m_ctx, val);
	}

	/// ֐̖߂lijZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(const _TCHAR* val)
	{
		SqliteStringW str = SqliteString(val).toUTF16();
		sqlite3_result_text16(
			m_ctx, str.c_str(),
			(int)str.length()*sizeof(wchar_t),
			SQLITE_TRANSIENT);
	}

	/// ֐̖߂liBLOBjZbg
	/**
	 * @param val ߂l
	 * @param nBytes ߂l̃oCg
	 * @param makeCopy val̃Rs[쐬Ė߂lƂꍇtrueA
	 * val|C^̂܂ܖ߂ꍇfalse
	 * @note makeCopyfalsȅꍇA֐ďoI
	 * SQLŖ߂l𗘗pI܂ŁAval̎wĂ͂ȂȂB
	 */
	void setReturn(const void* val, int nBytes, bool makeCopy=true)
	{
		sqlite3_result_blob(m_ctx, val, nBytes,
			makeCopy ? SQLITE_TRANSIENT : SQLITE_STATIC);
	}
};

/// [U`֐쐬邽߂̃x[XNX
class SqliteFunction
	: protected SqliteFunctionBase
{
public:
	/// RXgN^
	/**
	 * @param db ֐o^SQLitef[^x[Xnh
	 */
	SqliteFunction(sqlite3* db)
		: SqliteFunctionBase(db)
	{}

	virtual ~SqliteFunction()
	{
		destroy();
	}

	/// o^[U`֐Ăяo鎞ɌĂ΂
	/**
	 * @param argc argv̗vf
	 * @param argv [U`֐ɓnꂽ̔z
	 * @param userData create()ɓnuserDataƓ
	 * @note ߂lԂ[U`֐̏ꍇÃ\bh߂O
	 * SqliteFunctionBase::setReturn()pĖ߂lZbgKvB
	 */
	virtual void onCall(int argc, sqlite3_value** argv, void* userData) = 0;

	/// [U`֐SQLiteɓo^
	/**
	 * @param funcName [U`֐
	 * @param nArgs [U`֐̎̐
	 * @parma userData [Uf[^
	 */
	void create(const _TCHAR* funcName, int nArgs, void* userData)
	{
		m_name = funcName;
		m_nArgs = nArgs;
		SqliteStringW name = m_name.toUTF16();
		m_userData = userData;

		int res = sqlite3_create_function16(
			m_db, name.c_str(), nArgs, SQLITE_UTF16, this,
			delegateCall, NULL, NULL);

		if(SQLITE_OK != res)
		{
			std::string msg = "Can't create function: ";
			msg += SqliteString(funcName).toANSI().c_str();
			throw ConnectionException(msg.c_str());
		}
	}

	/// [U`֐̓o^
	void destroy()
	{
		if(!m_name.empty())
		{
			SqliteStringW name = m_name.toUTF16();
			sqlite3_create_function16(
				m_db, name.c_str(), m_nArgs, SQLITE_UTF16, this,
				NULL, NULL, NULL);
		}
	}

protected:
	/// gp
	static void delegateCall(
		sqlite3_context* ctx,
		int nArgs,
		sqlite3_value** params)
	{
		SqliteFunction* pThis = reinterpret_cast<SqliteFunction*>(sqlite3_user_data(ctx));
		pThis->m_ctx = ctx;
		pThis->onCall(nArgs, params, pThis->m_userData);
	}
};


/// [U`AOQ[g쐬邽߂̃x[XNX
class SqliteAggregate
	: protected SqliteFunctionBase
{
public:
	/// RXgN^
	/**
	 * @param db AOQ[go^SQLitef[^x[Xnh
	 */
	SqliteAggregate(sqlite3* db)
		: SqliteFunctionBase(db)
	{}

	virtual ~SqliteAggregate()
	{
		destroy();
	}

	/// AOQ[ĝPXebvƂɌĂяo
	/**
	 * @param argc argv̐
	 * @param argv AOQ[gɗ^ꂽ̐
	 * @param userData [Uf[^icreate()ɓnꂽ̂Ɠj
	 */
	virtual void onStep(int argc, sqlite3_value** argv, void* userData) = 0;

	/// AOQ[g̍Ō̃XebvIɌĂ΂
	/**
	 * @param userData icreate()ɓnꂽ̂Ɠj
	 */
	virtual void onFinal(void* userData) = 0;

	/// AOQ[gSQLiteɓo^
	/**
	 * @param funcName AOQ[g̖O
	 * @param nArgs AOQ[g̎̐
	 * @param userData onStep(), onFinal()ɓn[Uf[^
	 */
	void create(const _TCHAR* funcName, int nArgs, void* userData)
	{
		m_name = funcName;
		m_nArgs = nArgs;
		SqliteStringW name = m_name.toUTF16();
		m_userData = userData;

		int res = sqlite3_create_function16(
			m_db, name.c_str(), nArgs, SQLITE_UTF16, this,
			NULL, delegateStep, delegateFinal);

		if(SQLITE_OK != res)
		{
			std::string msg = "Can't create aggregate: ";
			msg += SqliteString(funcName).toANSI().c_str();
			throw ConnectionException(msg.c_str());
		}
	}

	/// AOQ[g̓o^
	void destroy()
	{
		if(!m_name.empty())
		{
			SqliteStringW name = m_name.toUTF16();
			sqlite3_create_function16(
				m_db, name.c_str(), m_nArgs, SQLITE_UTF16, this,
				NULL, NULL, NULL);
		}
	}

protected:
	/// gp
	static void delegateStep(
		sqlite3_context* ctx,
		int nArgs,
		sqlite3_value** params)
	{
		SqliteAggregate* pThis = reinterpret_cast<SqliteAggregate*>(sqlite3_user_data(ctx));
		pThis->onStep(nArgs, params, pThis->m_userData);
	}

	/// gp
	static void delegateFinal(
		sqlite3_context* ctx)
	{
		SqliteAggregate* pThis = reinterpret_cast<SqliteAggregate*>(sqlite3_user_data(ctx));
		pThis->onFinal(pThis->m_userData);
	}
};


/// [U`r֐쐬邽߂̃x[XNX
class SqliteCollation
{
protected:
	/// [U`r֐o^̃f[^x[Xnh
	sqlite3*		m_db;
	/// r֐̖O
	SqliteString	m_name;
	/// [Uf[^icreate()œnj
	void*			m_userData;

public:
	/// RXgN^
	/**
	 * @param r֐o^̃f[^x[Xnh
	 */
	SqliteCollation(sqlite3* db)
		: m_db(db)
	{}

	virtual ~SqliteCollation()
	{
		destroy();
	}

	/// rsxɌĂ΂BhNXŃI[o[ChB
	/**
	 * @param var1 
	 * @param var2 
	 * @param userData create()ɓnuserDataƓ
	 * @return var1var2菬ꍇ͕̒lA
	 * var1var2傫ꍇ͐̒lA
	 * var1var2ꍇ0ԂB
	 */
	virtual int onCompare(
		const SqliteString& var1,
		const SqliteString& var2,
		void* userData) = 0;

	/// r֐SQLiteɓo^
	/**
	 * @param funcName ֐
	 * @param userData onCompare()ɓn[Uf[^
	 */
	void create(const _TCHAR* funcName, void* userData)
	{
		m_name = funcName;
		m_userData = userData;

		SqliteStringW name = m_name.toUTF16();
		sqlite3_create_collation16(
			m_db, (const char*)name.c_str(), SQLITE_UTF16, this,
			delegateCompare);
	}

	/// r֐̓o^
	void destroy()
	{
		if(!m_name.empty())
		{
			SqliteStringW name = m_name.toUTF16();
			sqlite3_create_collation16(
				m_db, (const char*)name.c_str(), SQLITE_UTF16, this,
				NULL);
		}
	}

protected:
	/// gp
	static int delegateCompare(
		void* userData,
		int nLen1, const void* str1,
		int nLen2, const void* str2)
	{
		SqliteCollation* pThis = reinterpret_cast<SqliteCollation*>(userData);
		SqliteStringW var1, var2;
		var1.assign((const wchar_t*)str1, (size_t)nLen1/sizeof(wchar_t));
		var2.assign((const wchar_t*)str2, (size_t)nLen2/sizeof(wchar_t));

		return pThis->onCompare(
			SqliteString::fromUTF16(var1.c_str()),
			SqliteString::fromUTF16(var2.c_str()),
			pThis->m_userData);
	}
};


}; // end of namespace sqlite3plus

#endif SqliteFunction_H

